/*!
 * Browser tracker for Snowplow v4.6.2 (http://bit.ly/sp-js)
 * Copyright 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
 * Licensed under BSD-3-Clause
 */

(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.snowplowBrowserTracking = {}));
})(this, (function (exports) { 'use strict';

  /******************************************************************************
  Copyright (c) Microsoft Corporation.

  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */

  var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
  };

  function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
  }

  function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
  }

  function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
  }

  typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
  };

  /**
   * Convert array of 16 byte values to UUID string format of the form:
   * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
   */
  var byteToHex = [];
  for (var i = 0; i < 256; ++i) {
    byteToHex.push((i + 0x100).toString(16).slice(1));
  }
  function unsafeStringify(arr, offset = 0) {
    // Note: Be careful editing this code!  It's been tuned for performance
    // and works in ways you may not expect. See https://github.com/uuidjs/uuid/pull/434
    //
    // Note to future-self: No, you can't remove the `toLowerCase()` call.
    // REF: https://github.com/uuidjs/uuid/pull/677#issuecomment-1757351351
    return (byteToHex[arr[offset + 0]] + byteToHex[arr[offset + 1]] + byteToHex[arr[offset + 2]] + byteToHex[arr[offset + 3]] + '-' + byteToHex[arr[offset + 4]] + byteToHex[arr[offset + 5]] + '-' + byteToHex[arr[offset + 6]] + byteToHex[arr[offset + 7]] + '-' + byteToHex[arr[offset + 8]] + byteToHex[arr[offset + 9]] + '-' + byteToHex[arr[offset + 10]] + byteToHex[arr[offset + 11]] + byteToHex[arr[offset + 12]] + byteToHex[arr[offset + 13]] + byteToHex[arr[offset + 14]] + byteToHex[arr[offset + 15]]).toLowerCase();
  }

  // Unique ID creation requires a high quality random # generator. In the browser we therefore
  // require the crypto API and do not support built-in fallback to lower quality random number
  // generators (like Math.random()).

  var getRandomValues;
  var rnds8 = new Uint8Array(16);
  function rng() {
    // lazy load so that environments that need to polyfill have a chance to do so
    if (!getRandomValues) {
      // getRandomValues needs to be invoked in a context where "this" is a Crypto implementation.
      getRandomValues = typeof crypto !== 'undefined' && crypto.getRandomValues && crypto.getRandomValues.bind(crypto);
      if (!getRandomValues) {
        throw new Error('crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported');
      }
    }
    return getRandomValues(rnds8);
  }

  var randomUUID = typeof crypto !== 'undefined' && crypto.randomUUID && crypto.randomUUID.bind(crypto);
  var native = {
    randomUUID
  };

  function v4(options, buf, offset) {
    if (native.randomUUID && !buf && !options) {
      return native.randomUUID();
    }
    options = options || {};
    var rnds = options.random || (options.rng || rng)();

    // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`
    rnds[6] = rnds[6] & 0x0f | 0x40;
    rnds[8] = rnds[8] & 0x3f | 0x80;

    // Copy bytes to buffer, if provided
    if (buf) {
      offset = offset || 0;
      for (var i = 0; i < 16; ++i) {
        buf[offset + i] = rnds[i];
      }
      return buf;
    }
    return unsafeStringify(rnds);
  }

  /*!
   * Core functionality for Snowplow JavaScript trackers v4.6.2 (http://bit.ly/sp-js)
   * Copyright 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * Licensed under BSD-3-Clause
   */

  var version$1 = "4.6.2";

  /*
   * Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)
   * and Contributors (http://phpjs.org/authors)
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy of
   * this software and associated documentation files (the "Software"), to deal in
   * the Software without restriction, including without limitation the rights to
   * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
   * of the Software, and to permit persons to whom the Software is furnished to do
   * so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in all
   * copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   * SOFTWARE.
   */
  /**
   * Decodes a url safe Base 64 encoded string
   * @remarks See: {@link http://tools.ietf.org/html/rfc4648#page-7}
   * @param data - String to decode
   * @returns The decoded string
   */
  function base64urldecode(data) {
      if (!data) {
          return data;
      }
      var padding = 4 - (data.length % 4);
      switch (padding) {
          case 2:
              data += '==';
              break;
          case 3:
              data += '=';
              break;
      }
      var b64Data = data.replace(/-/g, '+').replace(/_/g, '/');
      return base64decode(b64Data);
  }
  /**
   * Encodes a string into a url safe Base 64 encoded string
   * @remarks See: {@link http://tools.ietf.org/html/rfc4648#page-7}
   * @param data - String to encode
   * @returns The url safe Base 64 string
   */
  function base64urlencode(data) {
      if (!data) {
          return data;
      }
      var enc = base64encode(data);
      return enc.replace(/=/g, '').replace(/\+/g, '-').replace(/\//g, '_');
  }
  var b64 = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
  /**
   * Encode string as base64.
   * Any type can be passed, but will be stringified
   *
   * @param data - string to encode
   * @returns base64-encoded string
   */
  function base64encode(data) {
      // discuss at: http://phpjs.org/functions/base64_encode/
      // original by: Tyler Akins (http://rumkin.com)
      // improved by: Bayron Guevara
      // improved by: Thunder.m
      // improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
      // improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
      // improved by: Rafał Kukawski (http://kukawski.pl)
      // bugfixed by: Pellentesque Malesuada
      // example 1: base64_encode('Kevin van Zonneveld');
      // returns 1: 'S2V2aW4gdmFuIFpvbm5ldmVsZA=='
      // example 2: base64_encode('a');
      // returns 2: 'YQ=='
      // example 3: base64_encode('✓ à la mode');
      // returns 3: '4pyTIMOgIGxhIG1vZGU='
      var o1, o2, o3, h1, h2, h3, h4, bits, i = 0, ac = 0;
      var tmp_arr = [];
      if (!data) {
          return data;
      }
      data = unescape(encodeURIComponent(data));
      do {
          // pack three octets into four hexets
          o1 = data.charCodeAt(i++);
          o2 = data.charCodeAt(i++);
          o3 = data.charCodeAt(i++);
          bits = (o1 << 16) | (o2 << 8) | o3;
          h1 = (bits >> 18) & 0x3f;
          h2 = (bits >> 12) & 0x3f;
          h3 = (bits >> 6) & 0x3f;
          h4 = bits & 0x3f;
          // use hexets to index into b64, and append result to encoded string
          tmp_arr[ac++] = b64.charAt(h1) + b64.charAt(h2) + b64.charAt(h3) + b64.charAt(h4);
      } while (i < data.length);
      var enc = tmp_arr.join('');
      var r = data.length % 3;
      return (r ? enc.slice(0, r - 3) : enc) + '==='.slice(r || 3);
  }
  /**
   * Decode base64 to string
   *
   * @param data - base64 to string
   * @returns decoded string
   */
  function base64decode(encodedData) {
      //  discuss at: http://locutus.io/php/base64_decode/
      // original by: Tyler Akins (http://rumkin.com)
      // improved by: Thunder.m
      // improved by: Kevin van Zonneveld (http://kvz.io)
      // improved by: Kevin van Zonneveld (http://kvz.io)
      //    input by: Aman Gupta
      //    input by: Brett Zamir (http://brett-zamir.me)
      // bugfixed by: Onno Marsman (https://twitter.com/onnomarsman)
      // bugfixed by: Pellentesque Malesuada
      // bugfixed by: Kevin van Zonneveld (http://kvz.io)
      // improved by: Indigo744
      //   example 1: base64_decode('S2V2aW4gdmFuIFpvbm5ldmVsZA==')
      //   returns 1: 'Kevin van Zonneveld'
      //   example 2: base64_decode('YQ==')
      //   returns 2: 'a'
      //   example 3: base64_decode('4pyTIMOgIGxhIG1vZGU=')
      //   returns 3: '✓ à la mode'
      // decodeUTF8string()
      // Internal function to decode properly UTF8 string
      // Adapted from Solution #1 at https://developer.mozilla.org/en-US/docs/Web/API/WindowBase64/Base64_encoding_and_decoding
      var decodeUTF8string = function (str) {
          // Going backwards: from bytestream, to percent-encoding, to original string.
          return decodeURIComponent(str
              .split('')
              .map(function (c) {
              return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
          })
              .join(''));
      };
      var o1, o2, o3, h1, h2, h3, h4, bits, i = 0, ac = 0, dec = '';
      var tmpArr = [];
      if (!encodedData) {
          return encodedData;
      }
      encodedData += '';
      do {
          // unpack four hexets into three octets using index points in b64
          h1 = b64.indexOf(encodedData.charAt(i++));
          h2 = b64.indexOf(encodedData.charAt(i++));
          h3 = b64.indexOf(encodedData.charAt(i++));
          h4 = b64.indexOf(encodedData.charAt(i++));
          bits = (h1 << 18) | (h2 << 12) | (h3 << 6) | h4;
          o1 = (bits >> 16) & 0xff;
          o2 = (bits >> 8) & 0xff;
          o3 = bits & 0xff;
          if (h3 === 64) {
              tmpArr[ac++] = String.fromCharCode(o1);
          }
          else if (h4 === 64) {
              tmpArr[ac++] = String.fromCharCode(o1, o2);
          }
          else {
              tmpArr[ac++] = String.fromCharCode(o1, o2, o3);
          }
      } while (i < encodedData.length);
      dec = tmpArr.join('');
      return decodeUTF8string(dec.replace(/\0+$/, ''));
  }

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  function payloadBuilder() {
      var dict = {}, allJson = [], jsonForProcessing = [], contextEntitiesForProcessing = [];
      var processor;
      var add = function (key, value) {
          if (value != null && value !== '') {
              // null also checks undefined
              dict[key] = value;
          }
      };
      var addDict = function (dict) {
          for (var key in dict) {
              if (Object.prototype.hasOwnProperty.call(dict, key)) {
                  add(key, dict[key]);
              }
          }
      };
      var addJson = function (keyIfEncoded, keyIfNotEncoded, json) {
          if (json && isNonEmptyJson(json)) {
              var jsonWithKeys = { keyIfEncoded: keyIfEncoded, keyIfNotEncoded: keyIfNotEncoded, json: json };
              jsonForProcessing.push(jsonWithKeys);
              allJson.push(jsonWithKeys);
          }
      };
      var addContextEntity = function (entity) {
          contextEntitiesForProcessing.push(entity);
      };
      return {
          add: add,
          addDict: addDict,
          addJson: addJson,
          addContextEntity: addContextEntity,
          getPayload: function () { return dict; },
          getJson: function () { return allJson; },
          withJsonProcessor: function (jsonProcessor) {
              processor = jsonProcessor;
          },
          build: function () {
              processor === null || processor === void 0 ? void 0 : processor(this, jsonForProcessing, contextEntitiesForProcessing);
              return dict;
          },
      };
  }
  /**
   * A helper to build a Snowplow request from a set of name-value pairs, provided using the add methods.
   * Will base64 encode JSON, if desired, on build
   *
   * @returns The request builder, with add and build methods
   */
  function payloadJsonProcessor(encodeBase64) {
      return function (payloadBuilder, jsonForProcessing, contextEntitiesForProcessing) {
          var add = function (json, keyIfEncoded, keyIfNotEncoded) {
              var str = JSON.stringify(json);
              if (encodeBase64) {
                  payloadBuilder.add(keyIfEncoded, base64urlencode(str));
              }
              else {
                  payloadBuilder.add(keyIfNotEncoded, str);
              }
          };
          var getContextFromPayload = function () {
              var payload = payloadBuilder.getPayload();
              if (encodeBase64 ? payload.cx : payload.co) {
                  return JSON.parse(encodeBase64 ? base64urldecode(payload.cx) : payload.co);
              }
              return undefined;
          };
          var combineContexts = function (originalContext, newContext) {
              var context = originalContext || getContextFromPayload();
              if (context) {
                  context.data = context.data.concat(newContext.data);
              }
              else {
                  context = newContext;
              }
              return context;
          };
          var context = undefined;
          for (var _i = 0, jsonForProcessing_1 = jsonForProcessing; _i < jsonForProcessing_1.length; _i++) {
              var json = jsonForProcessing_1[_i];
              if (json.keyIfEncoded === 'cx') {
                  context = combineContexts(context, json.json);
              }
              else {
                  add(json.json, json.keyIfEncoded, json.keyIfNotEncoded);
              }
          }
          jsonForProcessing.length = 0;
          if (contextEntitiesForProcessing.length) {
              var newContext = {
                  schema: 'iglu:com.snowplowanalytics.snowplow/contexts/jsonschema/1-0-0',
                  data: __spreadArray([], contextEntitiesForProcessing, true),
              };
              context = combineContexts(context, newContext);
              contextEntitiesForProcessing.length = 0;
          }
          if (context) {
              add(context, 'cx', 'co');
          }
      };
  }
  /**
   * Is property a non-empty JSON?
   * @param property - Checks if object is non-empty json
   */
  function isNonEmptyJson(property) {
      if (!isJson(property)) {
          return false;
      }
      for (var key in property) {
          if (Object.prototype.hasOwnProperty.call(property, key)) {
              return true;
          }
      }
      return false;
  }
  /**
   * Is property a JSON?
   * @param property - Checks if object is json
   */
  function isJson(property) {
      return (typeof property !== 'undefined' &&
          property !== null &&
          (property.constructor === {}.constructor || property.constructor === [].constructor));
  }

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  var label = 'Snowplow: ';
  var LOG_LEVEL;
  (function (LOG_LEVEL) {
      LOG_LEVEL[LOG_LEVEL["none"] = 0] = "none";
      LOG_LEVEL[LOG_LEVEL["error"] = 1] = "error";
      LOG_LEVEL[LOG_LEVEL["warn"] = 2] = "warn";
      LOG_LEVEL[LOG_LEVEL["debug"] = 3] = "debug";
      LOG_LEVEL[LOG_LEVEL["info"] = 4] = "info";
  })(LOG_LEVEL || (LOG_LEVEL = {}));
  var LOG = logger();
  function logger(logLevel) {
      if (logLevel === void 0) { logLevel = LOG_LEVEL.warn; }
      function setLogLevel(level) {
          if (LOG_LEVEL[level]) {
              logLevel = level;
          }
          else {
              logLevel = LOG_LEVEL.warn;
          }
      }
      /**
       * Log errors, with or without error object
       */
      function error(message, error) {
          var extraParams = [];
          for (var _i = 2; _i < arguments.length; _i++) {
              extraParams[_i - 2] = arguments[_i];
          }
          if (logLevel >= LOG_LEVEL.error && typeof console !== 'undefined') {
              var logMsg = label + message + '\n';
              if (error) {
                  console.error.apply(console, __spreadArray([logMsg + '\n', error], extraParams, false));
              }
              else {
                  console.error.apply(console, __spreadArray([logMsg], extraParams, false));
              }
          }
      }
      /**
       * Log warnings, with or without error object
       */
      function warn(message, error) {
          var extraParams = [];
          for (var _i = 2; _i < arguments.length; _i++) {
              extraParams[_i - 2] = arguments[_i];
          }
          if (logLevel >= LOG_LEVEL.warn && typeof console !== 'undefined') {
              var logMsg = label + message;
              if (error) {
                  console.warn.apply(console, __spreadArray([logMsg + '\n', error], extraParams, false));
              }
              else {
                  console.warn.apply(console, __spreadArray([logMsg], extraParams, false));
              }
          }
      }
      /**
       * Log debug messages
       */
      function debug(message) {
          var extraParams = [];
          for (var _i = 1; _i < arguments.length; _i++) {
              extraParams[_i - 1] = arguments[_i];
          }
          if (logLevel >= LOG_LEVEL.debug && typeof console !== 'undefined') {
              console.debug.apply(console, __spreadArray([label + message], extraParams, false));
          }
      }
      /**
       * Log info messages
       */
      function info(message) {
          var extraParams = [];
          for (var _i = 1; _i < arguments.length; _i++) {
              extraParams[_i - 1] = arguments[_i];
          }
          if (logLevel >= LOG_LEVEL.info && typeof console !== 'undefined') {
              console.info.apply(console, __spreadArray([label + message], extraParams, false));
          }
      }
      return { setLogLevel: setLogLevel, warn: warn, error: error, debug: debug, info: info };
  }

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  /**
   * Contains helper functions to aid in the addition and removal of Global Contexts
   */
  function globalContexts() {
      var globalPrimitives = [];
      var conditionalProviders = [];
      var namedPrimitives = {};
      var namedConditionalProviders = {};
      /**
       * Returns all applicable global contexts for a specified event
       * @param event - The event to check for applicable global contexts for
       * @returns An array of contexts
       */
      var assembleAllContexts = function (event) {
          var eventSchema = getUsefulSchema(event);
          var eventType = getEventType(event);
          var contexts = [];
          var generatedPrimitives = generatePrimitives(globalPrimitives.concat(Object.values(namedPrimitives)), event, eventType, eventSchema);
          contexts.push.apply(contexts, generatedPrimitives);
          var generatedConditionals = generateConditionals(conditionalProviders.concat(Object.values(namedConditionalProviders)), event, eventType, eventSchema);
          contexts.push.apply(contexts, generatedConditionals);
          return contexts;
      };
      return {
          getGlobalPrimitives: function () {
              return globalPrimitives.concat(Object.values(namedPrimitives));
          },
          getConditionalProviders: function () {
              return conditionalProviders.concat(Object.values(namedConditionalProviders));
          },
          addGlobalContexts: function (contexts) {
              if (Array.isArray(contexts)) {
                  var acceptedConditionalContexts = [];
                  var acceptedContextPrimitives = [];
                  for (var _i = 0, contexts_1 = contexts; _i < contexts_1.length; _i++) {
                      var context = contexts_1[_i];
                      if (isConditionalContextProvider(context)) {
                          acceptedConditionalContexts.push(context);
                      }
                      else if (isContextPrimitive(context)) {
                          acceptedContextPrimitives.push(context);
                      }
                  }
                  globalPrimitives = globalPrimitives.concat(acceptedContextPrimitives);
                  conditionalProviders = conditionalProviders.concat(acceptedConditionalContexts);
              }
              else {
                  for (var _a = 0, _b = Object.entries(contexts); _a < _b.length; _a++) {
                      var _c = _b[_a], name_1 = _c[0], context = _c[1];
                      if (isConditionalContextProvider(context)) {
                          namedConditionalProviders[name_1] = context;
                      }
                      else if (isContextPrimitive(context)) {
                          namedPrimitives[name_1] = context;
                      }
                  }
              }
          },
          clearGlobalContexts: function () {
              conditionalProviders = [];
              globalPrimitives = [];
              namedConditionalProviders = {};
              namedPrimitives = {};
          },
          removeGlobalContexts: function (contexts) {
              var _loop_1 = function (context) {
                  if (typeof context === 'string') {
                      delete namedConditionalProviders[context];
                      delete namedPrimitives[context];
                  }
                  else if (isConditionalContextProvider(context)) {
                      conditionalProviders = conditionalProviders.filter(function (item) { return !compareProvider(context, item); });
                  }
                  else if (isContextPrimitive(context)) {
                      globalPrimitives = globalPrimitives.filter(function (item) { return !compareProvider(context, item); });
                  }
              };
              for (var _i = 0, contexts_2 = contexts; _i < contexts_2.length; _i++) {
                  var context = contexts_2[_i];
                  _loop_1(context);
              }
          },
          getApplicableContexts: function (event) {
              return assembleAllContexts(event);
          },
      };
  }
  function pluginContexts(plugins) {
      /**
       * Add common contexts to every event
       *
       * @param array - additionalContexts List of user-defined contexts
       * @returns userContexts combined with commonContexts
       */
      return {
          addPluginContexts: function (additionalContexts) {
              var combinedContexts = additionalContexts
                  ? __spreadArray([], additionalContexts, true) : [];
              plugins.forEach(function (plugin) {
                  try {
                      if (plugin.contexts) {
                          combinedContexts.push.apply(combinedContexts, plugin.contexts());
                      }
                  }
                  catch (ex) {
                      LOG.error('Error adding plugin contexts', ex);
                  }
              });
              return combinedContexts;
          },
      };
  }
  /**
   * Slices a schema into its composite parts. Useful for ruleset filtering.
   * @param input - A schema string
   * @returns The vendor, schema name, major, minor and patch information of a schema string
   */
  function getSchemaParts(input) {
      var re = new RegExp('^iglu:([a-zA-Z0-9-_.]+)/([a-zA-Z0-9-_]+)/jsonschema/([1-9][0-9]*)-(0|[1-9][0-9]*)-(0|[1-9][0-9]*)$');
      var matches = re.exec(input);
      if (matches !== null)
          return matches.slice(1, 6);
      return undefined;
  }
  /**
   * Validates the vendor section of a schema string contains allowed wildcard values
   * @param parts - Array of parts from a schema string
   * @returns Whether the vendor validation parts are a valid combination
   */
  function validateVendorParts(parts) {
      if (parts[0] === '*' || parts[1] === '*') {
          return false; // no wildcard in first or second part
      }
      if (parts.slice(2).length > 0) {
          var asterisk = false;
          for (var _i = 0, _a = parts.slice(2); _i < _a.length; _i++) {
              var part = _a[_i];
              if (part === '*')
                  // mark when we've found a wildcard
                  asterisk = true;
              else if (asterisk)
                  // invalid if alpha parts come after wildcard
                  return false;
          }
          return true;
      }
      else if (parts.length == 2)
          return true;
      return false;
  }
  /**
   * Validates the vendor part of a schema string is valid for a rule set
   * @param input - Vendor part of a schema string
   * @returns Whether the vendor validation string is valid
   */
  function validateVendor(input) {
      var parts = input.split('.');
      if (parts && parts.length > 1)
          return validateVendorParts(parts);
      return false;
  }
  /**
   * Checks for validity of input and returns all the sections of a schema string that are used to match rules in a ruleset
   * @param input - A Schema string
   * @returns The sections of a schema string that are used to match rules in a ruleset
   */
  function getRuleParts(input) {
      var re = new RegExp('^iglu:((?:(?:[a-zA-Z0-9-_]+|\\*).)+(?:[a-zA-Z0-9-_]+|\\*))/([a-zA-Z0-9-_.]+|\\*)/jsonschema/([1-9][0-9]*|\\*)-(0|[1-9][0-9]*|\\*)-(0|[1-9][0-9]*|\\*)$');
      var matches = re.exec(input);
      if (matches !== null && validateVendor(matches[1]))
          return matches.slice(1, 6);
      return undefined;
  }
  /**
   * Ensures the rules specified in a schema string of a ruleset are valid
   * @param input - A Schema string
   * @returns if there rule is valid
   */
  function isValidRule(input) {
      var ruleParts = getRuleParts(input);
      if (ruleParts) {
          var vendor = ruleParts[0];
          return ruleParts.length === 5 && validateVendor(vendor);
      }
      return false;
  }
  /**
   * Check if a variable is an Array containing only strings
   * @param input - The variable to validate
   * @returns True if the input is an array containing only strings
   */
  function isStringArray(input) {
      return (Array.isArray(input) &&
          input.every(function (x) {
              return typeof x === 'string';
          }));
  }
  /**
   * Validates whether a rule set is an array of valid ruleset strings
   * @param input - The Array of rule set arguments
   * @returns True is the input is an array of valid rules
   */
  function isValidRuleSetArg(input) {
      if (isStringArray(input))
          return input.every(function (x) {
              return isValidRule(x);
          });
      else if (typeof input === 'string')
          return isValidRule(input);
      return false;
  }
  /**
   * Check if a variable is a valid, non-empty Self Describing JSON
   * @param input - The variable to validate
   * @returns True if a valid Self Describing JSON
   */
  function isSelfDescribingJson(input) {
      var sdj = input;
      if (isNonEmptyJson(sdj))
          if ('schema' in sdj && 'data' in sdj)
              return typeof sdj.schema === 'string' && typeof sdj.data === 'object';
      return false;
  }
  /**
   * Validates if the input object contains the expected properties of a ruleset
   * @param input - The object containing a rule set
   * @returns True if a valid rule set
   */
  function isRuleSet(input) {
      var ruleSet = input;
      var ruleCount = 0;
      if (input != null && typeof input === 'object' && !Array.isArray(input)) {
          if (Object.prototype.hasOwnProperty.call(ruleSet, 'accept')) {
              if (isValidRuleSetArg(ruleSet['accept'])) {
                  ruleCount += 1;
              }
              else {
                  return false;
              }
          }
          if (Object.prototype.hasOwnProperty.call(ruleSet, 'reject')) {
              if (isValidRuleSetArg(ruleSet['reject'])) {
                  ruleCount += 1;
              }
              else {
                  return false;
              }
          }
          // if either 'reject' or 'accept' or both exists,
          // we have a valid ruleset
          return ruleCount > 0 && ruleCount <= 2;
      }
      return false;
  }
  /**
   * Validates if the function can be a valid context generator function
   * @param input - The function to be validated
   */
  function isContextCallbackFunction(input) {
      return typeof input === 'function' && input.length <= 1;
  }
  /**
   * Validates if the function can be a valid context primitive function or self describing json
   * @param input - The function or orbject to be validated
   * @returns True if either a Context Generator or Self Describing JSON
   */
  function isContextPrimitive(input) {
      return isContextCallbackFunction(input) || isSelfDescribingJson(input);
  }
  /**
   * Validates if an array is a valid shape to be a Filter Provider
   * @param input - The Array of Context filter callbacks
   */
  function isFilterProvider(input) {
      if (Array.isArray(input)) {
          if (input.length === 2) {
              if (Array.isArray(input[1])) {
                  return isContextCallbackFunction(input[0]) && input[1].every(isContextPrimitive);
              }
              return isContextCallbackFunction(input[0]) && isContextPrimitive(input[1]);
          }
      }
      return false;
  }
  /**
   * Validates if an array is a valid shape to be an array of rule sets
   * @param input - The Array of Rule Sets
   */
  function isRuleSetProvider(input) {
      if (Array.isArray(input) && input.length === 2) {
          if (!isRuleSet(input[0]))
              return false;
          if (Array.isArray(input[1]))
              return input[1].every(isContextPrimitive);
          return isContextPrimitive(input[1]);
      }
      return false;
  }
  /**
   * Checks if an input array is either a filter provider or a rule set provider
   * @param input - An array of filter providers or rule set providers
   * @returns Whether the array is a valid {@link ConditionalContextProvider}
   */
  function isConditionalContextProvider(input) {
      return isFilterProvider(input) || isRuleSetProvider(input);
  }
  /**
   * Checks if a given schema matches any rules within the provided rule set
   * @param ruleSet - The rule set containing rules to match schema against
   * @param schema - The schema to be matched against the rule set
   */
  function matchSchemaAgainstRuleSet(ruleSet, schema) {
      var rejectCount = 0;
      var acceptCount = 0;
      var acceptRules = ruleSet['accept'];
      if (Array.isArray(acceptRules)) {
          if (ruleSet.accept.some(function (rule) { return matchSchemaAgainstRule(rule, schema); })) {
              acceptCount++;
          }
      }
      else if (typeof acceptRules === 'string') {
          if (matchSchemaAgainstRule(acceptRules, schema)) {
              acceptCount++;
          }
      }
      var rejectRules = ruleSet['reject'];
      if (Array.isArray(rejectRules)) {
          if (ruleSet.reject.some(function (rule) { return matchSchemaAgainstRule(rule, schema); })) {
              rejectCount++;
          }
      }
      else if (typeof rejectRules === 'string') {
          if (matchSchemaAgainstRule(rejectRules, schema)) {
              rejectCount++;
          }
      }
      if (acceptCount > 0 && rejectCount === 0) {
          return true;
      }
      else if (acceptCount === 0 && rejectCount > 0) {
          return false;
      }
      return false;
  }
  /**
   * Checks if a given schema matches a specific rule from a rule set
   * @param rule - The rule to match schema against
   * @param schema - The schema to be matched against the rule
   */
  function matchSchemaAgainstRule(rule, schema) {
      if (!isValidRule(rule))
          return false;
      var ruleParts = getRuleParts(rule);
      var schemaParts = getSchemaParts(schema);
      if (ruleParts && schemaParts) {
          if (!matchVendor(ruleParts[0], schemaParts[0]))
              return false;
          for (var i = 1; i < 5; i++) {
              if (!matchPart(ruleParts[i], schemaParts[i]))
                  return false;
          }
          return true; // if it hasn't failed, it passes
      }
      return false;
  }
  function matchVendor(rule, vendor) {
      // rule and vendor must have same number of elements
      var vendorParts = vendor.split('.');
      var ruleParts = rule.split('.');
      if (vendorParts && ruleParts) {
          if (vendorParts.length !== ruleParts.length)
              return false;
          for (var i = 0; i < ruleParts.length; i++) {
              if (!matchPart(vendorParts[i], ruleParts[i]))
                  return false;
          }
          return true;
      }
      return false;
  }
  function matchPart(rule, schema) {
      // parts should be the string nested between slashes in the URI: /example/
      return (rule && schema && rule === '*') || rule === schema;
  }
  // Returns the "useful" schema, i.e. what would someone want to use to identify events.
  // For some events this is the 'e' property but for unstructured events, this is the
  // 'schema' from the 'ue_px' field.
  function getUsefulSchema(sb) {
      var eventJson = sb.getJson();
      for (var _i = 0, eventJson_1 = eventJson; _i < eventJson_1.length; _i++) {
          var json = eventJson_1[_i];
          if (json.keyIfEncoded === 'ue_px' && typeof json.json['data'] === 'object') {
              var schema = json.json['data']['schema'];
              if (typeof schema == 'string') {
                  return schema;
              }
          }
      }
      return '';
  }
  function getEventType(payloadBuilder) {
      var eventType = payloadBuilder.getPayload()['e'];
      return typeof eventType === 'string' ? eventType : '';
  }
  function buildGenerator(generator, event, eventType, eventSchema) {
      var contextGeneratorResult = undefined;
      try {
          // try to evaluate context generator
          var args = {
              event: event.getPayload(),
              eventType: eventType,
              eventSchema: eventSchema,
          };
          contextGeneratorResult = generator(args);
          // determine if the produced result is a valid SDJ
          if (Array.isArray(contextGeneratorResult) && contextGeneratorResult.every(isSelfDescribingJson)) {
              return contextGeneratorResult;
          }
          else if (isSelfDescribingJson(contextGeneratorResult)) {
              return contextGeneratorResult;
          }
          else {
              return undefined;
          }
      }
      catch (error) {
          contextGeneratorResult = undefined;
      }
      return contextGeneratorResult;
  }
  function normalizeToArray(input) {
      if (Array.isArray(input)) {
          return input;
      }
      return Array.of(input);
  }
  function generatePrimitives(contextPrimitives, event, eventType, eventSchema) {
      var _a;
      var normalizedInputs = normalizeToArray(contextPrimitives);
      var partialEvaluate = function (primitive) {
          var result = evaluatePrimitive(primitive, event, eventType, eventSchema);
          if (result && result.length !== 0) {
              return result;
          }
          return undefined;
      };
      var generatedContexts = normalizedInputs.map(partialEvaluate);
      return (_a = []).concat.apply(_a, generatedContexts.filter(function (c) { return c != null && c.filter(Boolean); }));
  }
  function evaluatePrimitive(contextPrimitive, event, eventType, eventSchema) {
      if (isSelfDescribingJson(contextPrimitive)) {
          return [contextPrimitive];
      }
      else if (isContextCallbackFunction(contextPrimitive)) {
          var generatorOutput = buildGenerator(contextPrimitive, event, eventType, eventSchema);
          if (isSelfDescribingJson(generatorOutput)) {
              return [generatorOutput];
          }
          else if (Array.isArray(generatorOutput)) {
              return generatorOutput;
          }
      }
      return undefined;
  }
  function evaluateProvider(provider, event, eventType, eventSchema) {
      if (isFilterProvider(provider)) {
          var filter = provider[0];
          var filterResult = false;
          try {
              var args = {
                  event: event.getPayload(),
                  eventType: eventType,
                  eventSchema: eventSchema,
              };
              filterResult = filter(args);
          }
          catch (error) {
              filterResult = false;
          }
          if (filterResult === true) {
              return generatePrimitives(provider[1], event, eventType, eventSchema);
          }
      }
      else if (isRuleSetProvider(provider)) {
          if (matchSchemaAgainstRuleSet(provider[0], eventSchema)) {
              return generatePrimitives(provider[1], event, eventType, eventSchema);
          }
      }
      return [];
  }
  function compareProviderPart(a, b) {
      if (typeof a === 'function')
          return a === b;
      return JSON.stringify(a) === JSON.stringify(b);
  }
  function compareProvider(a, b) {
      if (isConditionalContextProvider(a)) {
          if (!isConditionalContextProvider(b))
              return false;
          var ruleA = a[0], primitivesA = a[1];
          var ruleB = b[0], primitivesB_1 = b[1];
          if (!compareProviderPart(ruleA, ruleB))
              return false;
          if (Array.isArray(primitivesA)) {
              if (!Array.isArray(primitivesB_1))
                  return false;
              if (primitivesA.length !== primitivesB_1.length)
                  return false;
              return primitivesA.reduce(function (matches, a, i) { return matches && compareProviderPart(a, primitivesB_1[i]); }, true);
          }
          else {
              if (Array.isArray(primitivesB_1))
                  return false;
              return compareProviderPart(primitivesA, primitivesB_1);
          }
      }
      else if (isContextPrimitive(a)) {
          if (!isContextPrimitive(b))
              return false;
          return compareProviderPart(a, b);
      }
      return false;
  }
  function generateConditionals(providers, event, eventType, eventSchema) {
      var _a;
      var normalizedInput = normalizeToArray(providers);
      var partialEvaluate = function (provider) {
          var result = evaluateProvider(provider, event, eventType, eventSchema);
          if (result && result.length !== 0) {
              return result;
          }
          return undefined;
      };
      var generatedContexts = normalizedInput.map(partialEvaluate);
      return (_a = []).concat.apply(_a, generatedContexts.filter(function (c) { return c != null && c.filter(Boolean); }));
  }

  /**
   * Create a new EventStorePayload
   */
  function newEventStorePayload(_a) {
      var payload = _a.payload, _b = _a.svrAnon, svrAnon = _b === void 0 ? false : _b;
      return {
          payload: payload,
          svrAnon: svrAnon,
      };
  }

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  /**
   * Transform optional/old-behavior number timestamp into`Timestamp` ADT
   *
   * @param timestamp - optional number or timestamp object
   * @returns correct timestamp object
   */
  function getTimestamp(timestamp) {
      if (timestamp == null) {
          return { type: 'dtm', value: new Date().getTime() };
      }
      else if (typeof timestamp === 'number') {
          return { type: 'dtm', value: timestamp };
      }
      else if (timestamp.type === 'ttm') {
          // We can return timestamp here, but this is safer fallback
          return { type: 'ttm', value: timestamp.value };
      }
      else {
          return { type: 'dtm', value: timestamp.value || new Date().getTime() };
      }
  }
  /**
   * Create a tracker core object
   *
   * @param base64 - Whether to base 64 encode contexts and self describing event JSONs
   * @param corePlugins - The core plugins to be processed with each event
   * @param callback - Function applied to every payload dictionary object
   * @returns Tracker core
   */
  function trackerCore(configuration) {
      if (configuration === void 0) { configuration = {}; }
      function newCore(base64, corePlugins, callback) {
          var pluginContextsHelper = pluginContexts(corePlugins), globalContextsHelper = globalContexts();
          var encodeBase64 = base64, payloadPairs = {}; // Dictionary of key-value pairs which get added to every payload, e.g. tracker version
          /**
           * Wraps an array of custom contexts in a self-describing JSON
           *
           * @param contexts - Array of custom context self-describing JSONs
           * @returns Outer JSON
           */
          function completeContexts(contexts) {
              if (contexts && contexts.length) {
                  return {
                      schema: 'iglu:com.snowplowanalytics.snowplow/contexts/jsonschema/1-0-0',
                      data: contexts,
                  };
              }
              return undefined;
          }
          /**
           * Adds all global contexts to a contexts array
           *
           * @param pb - PayloadData
           * @param contexts - Custom contexts relating to the event
           */
          function attachGlobalContexts(pb, contexts) {
              var applicableContexts = globalContextsHelper.getApplicableContexts(pb);
              var returnedContexts = [];
              if (contexts && contexts.length) {
                  returnedContexts.push.apply(returnedContexts, contexts);
              }
              if (applicableContexts && applicableContexts.length) {
                  returnedContexts.push.apply(returnedContexts, applicableContexts);
              }
              return returnedContexts;
          }
          /**
           * Gets called by every trackXXX method
           * Adds context and payloadPairs name-value pairs to the payload
           * Applies the callback to the built payload
           *
           * @param pb - Payload
           * @param context - Custom contexts relating to the event
           * @param timestamp - Timestamp of the event
           * @returns Payload after the callback is applied or undefined if the event is skipped
           */
          function track(pb, context, timestamp) {
              if (!active) {
                  LOG.error('Track called on deactivated tracker');
                  return undefined;
              }
              pb.withJsonProcessor(payloadJsonProcessor(encodeBase64));
              pb.add('eid', v4());
              pb.addDict(payloadPairs);
              var tstamp = getTimestamp(timestamp);
              pb.add(tstamp.type, tstamp.value.toString());
              var allContexts = attachGlobalContexts(pb, pluginContextsHelper.addPluginContexts(context));
              var wrappedContexts = completeContexts(allContexts);
              if (wrappedContexts !== undefined) {
                  pb.addJson('cx', 'co', wrappedContexts);
              }
              corePlugins.forEach(function (plugin) {
                  try {
                      if (plugin.beforeTrack) {
                          plugin.beforeTrack(pb);
                      }
                  }
                  catch (ex) {
                      LOG.error('Plugin beforeTrack', ex);
                  }
              });
              // Call the filter on plugins to determine if the event should be tracked
              var skip = corePlugins.find(function (plugin) {
                  try {
                      return plugin.filter && plugin.filter(pb.build()) === false;
                  }
                  catch (ex) {
                      LOG.error('Plugin filter', ex);
                      return false;
                  }
              });
              if (skip) {
                  return undefined;
              }
              if (typeof callback === 'function') {
                  callback(pb);
              }
              var finalPayload = pb.build();
              corePlugins.forEach(function (plugin) {
                  try {
                      if (plugin.afterTrack) {
                          plugin.afterTrack(finalPayload);
                      }
                  }
                  catch (ex) {
                      LOG.error('Plugin afterTrack', ex);
                  }
              });
              return finalPayload;
          }
          /**
           * Set a persistent key-value pair to be added to every payload
           *
           * @param key - Field name
           * @param value - Field value
           */
          function addPayloadPair(key, value) {
              payloadPairs[key] = value;
          }
          var core = {
              track: track,
              addPayloadPair: addPayloadPair,
              getBase64Encoding: function () {
                  return encodeBase64;
              },
              setBase64Encoding: function (encode) {
                  encodeBase64 = encode;
              },
              addPayloadDict: function (dict) {
                  for (var key in dict) {
                      if (Object.prototype.hasOwnProperty.call(dict, key)) {
                          payloadPairs[key] = dict[key];
                      }
                  }
              },
              resetPayloadPairs: function (dict) {
                  payloadPairs = isJson(dict) ? dict : {};
              },
              setTrackerVersion: function (version) {
                  addPayloadPair('tv', version);
              },
              setTrackerNamespace: function (name) {
                  addPayloadPair('tna', name);
              },
              setAppId: function (appId) {
                  addPayloadPair('aid', appId);
              },
              setPlatform: function (value) {
                  addPayloadPair('p', value);
              },
              setUserId: function (userId) {
                  addPayloadPair('uid', userId);
              },
              setScreenResolution: function (width, height) {
                  addPayloadPair('res', width + 'x' + height);
              },
              setViewport: function (width, height) {
                  addPayloadPair('vp', width + 'x' + height);
              },
              setColorDepth: function (depth) {
                  addPayloadPair('cd', depth);
              },
              setTimezone: function (timezone) {
                  addPayloadPair('tz', timezone);
              },
              setLang: function (lang) {
                  addPayloadPair('lang', lang);
              },
              setIpAddress: function (ip) {
                  addPayloadPair('ip', ip);
              },
              setUseragent: function (useragent) {
                  addPayloadPair('ua', useragent);
              },
              addGlobalContexts: function (contexts) {
                  globalContextsHelper.addGlobalContexts(contexts);
              },
              clearGlobalContexts: function () {
                  globalContextsHelper.clearGlobalContexts();
              },
              removeGlobalContexts: function (contexts) {
                  globalContextsHelper.removeGlobalContexts(contexts);
              },
          };
          return core;
      }
      var active = true;
      var base64 = configuration.base64, corePlugins = configuration.corePlugins, callback = configuration.callback, plugins = corePlugins !== null && corePlugins !== void 0 ? corePlugins : [], partialCore = newCore(base64 !== null && base64 !== void 0 ? base64 : true, plugins, callback), core = __assign(__assign({}, partialCore), { addPlugin: function (configuration) {
              var _a, _b;
              var plugin = configuration.plugin;
              plugins.push(plugin);
              (_a = plugin.logger) === null || _a === void 0 ? void 0 : _a.call(plugin, LOG);
              (_b = plugin.activateCorePlugin) === null || _b === void 0 ? void 0 : _b.call(plugin, core);
          }, deactivate: function () {
              plugins.forEach(function (plugin) {
                  var _a;
                  (_a = plugin.deactivatePlugin) === null || _a === void 0 ? void 0 : _a.call(plugin, core);
              });
              plugins.length = 0;
              active = false;
          } });
      plugins === null || plugins === void 0 ? void 0 : plugins.forEach(function (plugin) {
          var _a, _b;
          (_a = plugin.logger) === null || _a === void 0 ? void 0 : _a.call(plugin, LOG);
          (_b = plugin.activateCorePlugin) === null || _b === void 0 ? void 0 : _b.call(plugin, core);
      });
      return core;
  }
  /**
   * Build a self-describing event
   * A custom event type, allowing for an event to be tracked using your own custom schema
   * and a data object which conforms to the supplied schema
   *
   * @param event - Contains the properties and schema location for the event
   * @returns PayloadBuilder to be sent to {@link @snowplow/tracker-core#TrackerCore.track}
   */
  function buildSelfDescribingEvent(event) {
      var _a = event.event, schema = _a.schema, data = _a.data, pb = payloadBuilder();
      var ueJson = {
          schema: 'iglu:com.snowplowanalytics.snowplow/unstruct_event/jsonschema/1-0-0',
          data: { schema: schema, data: data },
      };
      pb.add('e', 'ue');
      pb.addJson('ue_px', 'ue_pr', ueJson);
      return pb;
  }
  /**
   * Build a Page View Event
   * Represents a Page View, which is typically fired as soon as possible when a web page
   * is loaded within the users browser. Often also fired on "virtual page views" within
   * Single Page Applications (SPA).
   *
   * @param event - Contains the properties for the Page View event
   * @returns PayloadBuilder to be sent to {@link @snowplow/tracker-core#TrackerCore.track}
   */
  function buildPageView(event) {
      var pageUrl = event.pageUrl, pageTitle = event.pageTitle, referrer = event.referrer, pb = payloadBuilder();
      pb.add('e', 'pv'); // 'pv' for Page View
      pb.add('url', pageUrl);
      pb.add('page', pageTitle);
      pb.add('refr', referrer);
      return pb;
  }
  /**
   * Build a Page Ping Event
   * Fires when activity tracking is enabled in the browser.
   * Tracks same information as the last tracked Page View and includes scroll
   * information from the current page view
   *
   * @param event - Contains the properties for the Page Ping event
   * @returns PayloadBuilder to be sent to {@link @snowplow/tracker-core#TrackerCore.track}
   */
  function buildPagePing(event) {
      var pageUrl = event.pageUrl, pageTitle = event.pageTitle, referrer = event.referrer, minXOffset = event.minXOffset, maxXOffset = event.maxXOffset, minYOffset = event.minYOffset, maxYOffset = event.maxYOffset, pb = payloadBuilder();
      pb.add('e', 'pp'); // 'pp' for Page Ping
      pb.add('url', pageUrl);
      pb.add('page', pageTitle);
      pb.add('refr', referrer);
      if (minXOffset && !isNaN(Number(minXOffset)))
          pb.add('pp_mix', minXOffset.toString());
      if (maxXOffset && !isNaN(Number(maxXOffset)))
          pb.add('pp_max', maxXOffset.toString());
      if (minYOffset && !isNaN(Number(minYOffset)))
          pb.add('pp_miy', minYOffset.toString());
      if (maxYOffset && !isNaN(Number(maxYOffset)))
          pb.add('pp_may', maxYOffset.toString());
      return pb;
  }
  /**
   * Build a Structured Event
   * A classic style of event tracking, allows for easier movement between analytics
   * systems. A loosely typed event, creating a Self Describing event is preferred, but
   * useful for interoperability.
   *
   * @param event - Contains the properties for the Structured event
   * @returns PayloadBuilder to be sent to {@link @snowplow/tracker-core#TrackerCore.track}
   */
  function buildStructEvent(event) {
      var category = event.category, action = event.action, label = event.label, property = event.property, value = event.value, pb = payloadBuilder();
      pb.add('e', 'se'); // 'se' for Structured Event
      pb.add('se_ca', category);
      pb.add('se_ac', action);
      pb.add('se_la', label);
      pb.add('se_pr', property);
      pb.add('se_va', value == null ? undefined : value.toString());
      return pb;
  }

  function newInMemoryEventStore(_a) {
      var _b = _a.maxSize, maxSize = _b === void 0 ? 1000 : _b, _c = _a.events, events = _c === void 0 ? [] : _c;
      var store = __spreadArray([], events, true);
      var count = function () { return Promise.resolve(store.length); };
      return {
          count: count,
          add: function (payload) {
              store.push(payload);
              while (store.length > maxSize) {
                  store.shift();
              }
              return count();
          },
          removeHead: function (count) {
              for (var i = 0; i < count; i++) {
                  store.shift();
              }
              return Promise.resolve();
          },
          iterator: function () {
              var index = 0;
              // copy the store to prevent mutation
              var events = __spreadArray([], store, true);
              return {
                  next: function () {
                      if (index < events.length) {
                          return Promise.resolve({ value: events[index++], done: false });
                      }
                      return Promise.resolve({ value: undefined, done: true });
                  },
              };
          },
          getAll: function () { return Promise.resolve(__spreadArray([], store, true)); },
          getAllPayloads: function () { return Promise.resolve(store.map(function (e) { return e.payload; })); },
      };
  }

  var PAYLOAD_DATA_SCHEMA = 'iglu:com.snowplowanalytics.snowplow/payload_data/jsonschema/1-0-4';

  /**
   * Enclose an array of events in a self-describing payload_data JSON string
   *
   * @param array - events Batch of events
   * @returns string payload_data self-describing JSON
   */
  function encloseInPayloadDataEnvelope(events) {
      return JSON.stringify({
          schema: PAYLOAD_DATA_SCHEMA,
          data: events,
      });
  }
  /**
   * Attaches the STM field to outbound POST events.
   *
   * @param events - the events to attach the STM to
   */
  function attachStmToEvent(events) {
      var stm = new Date().getTime().toString();
      for (var i = 0; i < events.length; i++) {
          events[i]['stm'] = stm;
      }
      return events;
  }
  function newEmitterRequest(_a) {
      var endpoint = _a.endpoint, _b = _a.protocol, protocol = _b === void 0 ? 'https' : _b, port = _a.port, _c = _a.eventMethod, eventMethod = _c === void 0 ? 'post' : _c, customHeaders = _a.customHeaders, connectionTimeout = _a.connectionTimeout, _d = _a.keepalive, keepalive = _d === void 0 ? false : _d, _e = _a.postPath, postPath = _e === void 0 ? '/com.snowplowanalytics.snowplow/tp2' : _e, _f = _a.useStm, useStm = _f === void 0 ? true : _f, _g = _a.maxPostBytes, maxPostBytes = _g === void 0 ? 40000 : _g, _h = _a.credentials, credentials = _h === void 0 ? 'include' : _h;
      var events = [];
      var usePost = eventMethod.toLowerCase() === 'post';
      var timer;
      var abortController;
      function countBytes() {
          var count = events.reduce(function (acc, event) { return acc + (usePost ? event.getPOSTRequestBytesCount() : event.getGETRequestBytesCount()); }, 0);
          if (usePost) {
              count += 88; // 88 bytes for the payload_data envelope
          }
          return count;
      }
      function countEvents() {
          return events.length;
      }
      function getServerAnonymizationOfExistingEvents() {
          return events.length > 0 ? events[0].getServerAnonymization() : undefined;
      }
      function addEvent(event) {
          if (events.length > 0 && getServerAnonymizationOfExistingEvents() !== event.getServerAnonymization()) {
              return false;
          }
          else {
              events.push(event);
              return true;
          }
      }
      function getEvents() {
          return events;
      }
      function isFull() {
          if (usePost) {
              return countBytes() >= maxPostBytes;
          }
          else {
              return events.length >= 1;
          }
      }
      function createHeaders() {
          var headers = new Headers();
          if (usePost) {
              headers.append('Content-Type', 'application/json; charset=UTF-8');
          }
          if (customHeaders) {
              Object.keys(customHeaders).forEach(function (key) {
                  headers.append(key, customHeaders[key]);
              });
          }
          if (getServerAnonymizationOfExistingEvents()) {
              headers.append('SP-Anonymous', '*');
          }
          return headers;
      }
      function getFullCollectorUrl() {
          var collectorUrl = endpoint;
          if (!endpoint.includes('://')) {
              collectorUrl = "".concat(protocol, "://").concat(endpoint);
          }
          if (port) {
              collectorUrl = "".concat(collectorUrl, ":").concat(port);
          }
          var path = usePost ? postPath : '/i';
          return collectorUrl + path;
      }
      function makeRequest(url, options) {
          closeRequest(false);
          abortController = new AbortController();
          timer = setTimeout(function () {
              var reason = 'Request timed out';
              console.error(reason);
              timer = undefined;
              closeRequest(false, reason);
          }, connectionTimeout !== null && connectionTimeout !== void 0 ? connectionTimeout : 5000);
          var requestOptions = __assign({ headers: createHeaders(), signal: abortController.signal, keepalive: keepalive, credentials: credentials }, options);
          var request = new Request(url, requestOptions);
          return request;
      }
      function makePostRequest() {
          var batch = attachStmToEvent(events.map(function (event) { return event.getPOSTRequestBody(); }));
          return makeRequest(getFullCollectorUrl(), {
              method: 'POST',
              body: encloseInPayloadDataEnvelope(batch),
          });
      }
      function makeGetRequest() {
          if (events.length !== 1) {
              throw new Error('Only one event can be sent in a GET request');
          }
          var event = events[0];
          var url = event.getGETRequestURL(getFullCollectorUrl(), useStm);
          return makeRequest(url, {
              method: 'GET',
          });
      }
      function toRequest() {
          if (events.length === 0) {
              return undefined;
          }
          if (usePost) {
              return makePostRequest();
          }
          else {
              return makeGetRequest();
          }
      }
      function closeRequest(successful, reason) {
          if (timer !== undefined) {
              clearTimeout(timer);
              timer = undefined;
          }
          if (abortController !== undefined) {
              var controller = abortController;
              abortController = undefined;
              if (!successful) {
                  controller.abort(reason);
              }
          }
      }
      return {
          addEvent: addEvent,
          getEvents: getEvents,
          toRequest: toRequest,
          countBytes: countBytes,
          countEvents: countEvents,
          isFull: isFull,
          closeRequest: closeRequest,
      };
  }

  /**
   * Count the number of bytes a string will occupy when UTF-8 encoded
   * Taken from http://stackoverflow.com/questions/2848462/count-bytes-in-textarea-using-javascript/
   *
   * @param s - The string
   * @returns number Length of s in bytes when UTF-8 encoded
   */
  function getUTF8Length(s) {
      var len = 0;
      for (var i = 0; i < s.length; i++) {
          var code = s.charCodeAt(i);
          if (code <= 0x7f) {
              len += 1;
          }
          else if (code <= 0x7ff) {
              len += 2;
          }
          else if (code >= 0xd800 && code <= 0xdfff) {
              // Surrogate pair: These take 4 bytes in UTF-8 and 2 chars in UCS-2
              // (Assume next char is the other [valid] half and just skip it)
              len += 4;
              i++;
          }
          else if (code < 0xffff) {
              len += 3;
          }
          else {
              len += 4;
          }
      }
      return len;
  }
  /*
    * Convert a dictionary to a querystring
    * The context field is the last in the querystring
    */
  function getQuerystring(request) {
      var lowPriorityKeys = { co: true, cx: true };
      var args = [];
      for (var key in request) {
          if (request.hasOwnProperty(key) && !lowPriorityKeys[key]) {
              args.push(key + '=' + encodeURIComponent(request[key]));
          }
      }
      for (var contextKey in lowPriorityKeys) {
          if (request.hasOwnProperty(contextKey) && lowPriorityKeys[contextKey]) {
              args.push(contextKey + '=' + encodeURIComponent(request[contextKey]));
          }
      }
      return '?' + args.join('&');
  }
  /*
    * Convert numeric fields to strings to match payload_data schema
    */
  function preparePostBody(request) {
      var cleanedRequest = Object.keys(request)
          .map(function (k) { return [k, request[k]]; })
          .reduce(function (acc, _a) {
          var key = _a[0], value = _a[1];
          acc[key] = value.toString();
          return acc;
      }, {});
      return cleanedRequest;
  }
  function newEmitterEvent(eventStorePayload) {
      var querystring = null;
      var postBody = null;
      var byteCountGET = null;
      var byteCountPOST = null;
      function getPayload() {
          return eventStorePayload.payload;
      }
      function getServerAnonymization() {
          var _a;
          return (_a = eventStorePayload.svrAnon) !== null && _a !== void 0 ? _a : false;
      }
      function getCachedQuerystring(payload) {
          if (querystring === null) {
              querystring = getQuerystring(payload);
          }
          return querystring;
      }
      function getGETRequestURL(collectorUrl, useStm) {
          var querystring = getCachedQuerystring(getPayload());
          if (useStm) {
              return collectorUrl + querystring.replace('?', '?stm=' + new Date().getTime() + '&');
          }
          return collectorUrl + querystring;
      }
      function getGETRequestBytesCount() {
          if (byteCountGET === null) {
              var querystring_1 = getCachedQuerystring(getPayload());
              byteCountGET = getUTF8Length(querystring_1);
          }
          return byteCountGET;
      }
      function getPOSTRequestBody() {
          if (postBody === null) {
              postBody = preparePostBody(getPayload());
          }
          return postBody;
      }
      function getPOSTRequestBytesCount() {
          if (byteCountPOST === null) {
              byteCountPOST = getUTF8Length(JSON.stringify(getPOSTRequestBody()));
          }
          return byteCountPOST;
      }
      return {
          getPayload: getPayload,
          getServerAnonymization: getServerAnonymization,
          getGETRequestURL: getGETRequestURL,
          getGETRequestBytesCount: getGETRequestBytesCount,
          getPOSTRequestBody: getPOSTRequestBody,
          getPOSTRequestBytesCount: getPOSTRequestBytesCount,
      };
  }

  function newEmitter(_a) {
      var endpoint = _a.endpoint, _b = _a.eventMethod, eventMethod = _b === void 0 ? 'post' : _b, postPath = _a.postPath, protocol = _a.protocol, port = _a.port, _c = _a.maxPostBytes, maxPostBytes = _c === void 0 ? 40000 : _c, maxGetBytes = _a.maxGetBytes, _d = _a.bufferSize, bufferSize = _d === void 0 ? 1 : _d, customHeaders = _a.customHeaders, serverAnonymization = _a.serverAnonymization, connectionTimeout = _a.connectionTimeout, keepalive = _a.keepalive, cookieExtensionService = _a.cookieExtensionService, idService = _a.idService, _e = _a.dontRetryStatusCodes, dontRetryStatusCodes = _e === void 0 ? [] : _e, _f = _a.retryStatusCodes, retryStatusCodes = _f === void 0 ? [] : _f, _g = _a.retryFailedRequests, retryFailedRequests = _g === void 0 ? true : _g, onRequestFailure = _a.onRequestFailure, onRequestSuccess = _a.onRequestSuccess, _h = _a.customFetch, customFetch = _h === void 0 ? fetch : _h, useStm = _a.useStm, _j = _a.eventStore, eventStore = _j === void 0 ? newInMemoryEventStore({}) : _j, credentials = _a.credentials;
      /* `cookieExtensionService` gets priority until `idService` is completely removed. */
      cookieExtensionService = cookieExtensionService || idService;
      var cookieExtensionServiceCalled = false;
      var flushInProgress = false;
      var usePost = eventMethod.toLowerCase() === 'post';
      dontRetryStatusCodes = dontRetryStatusCodes.concat([400, 401, 403, 410, 422]);
      function shouldRetryForStatusCode(statusCode) {
          // success, don't retry
          if (statusCode >= 200 && statusCode < 300) {
              return false;
          }
          if (!retryFailedRequests) {
              return false;
          }
          // retry if status code among custom user-supplied retry codes
          if (retryStatusCodes.includes(statusCode)) {
              return true;
          }
          // retry if status code *not* among the don't retry codes
          return !dontRetryStatusCodes.includes(statusCode);
      }
      function callOnRequestSuccess(payloads, response) {
          if (onRequestSuccess !== undefined) {
              setTimeout(function () {
                  try {
                      onRequestSuccess === null || onRequestSuccess === void 0 ? void 0 : onRequestSuccess(payloads, response);
                  }
                  catch (e) {
                      LOG.error('Error in onRequestSuccess', e);
                  }
              }, 0);
          }
      }
      function callOnRequestFailure(failure, response) {
          if (onRequestFailure !== undefined) {
              setTimeout(function () {
                  try {
                      onRequestFailure === null || onRequestFailure === void 0 ? void 0 : onRequestFailure(failure, response);
                  }
                  catch (e) {
                      LOG.error('Error in onRequestFailure', e);
                  }
              }, 0);
          }
      }
      function executeRequest(request) {
          return __awaiter(this, void 0, void 0, function () {
              var fetchRequest, payloads, response, willRetry, e_1, message;
              return __generator(this, function (_a) {
                  switch (_a.label) {
                      case 0:
                          fetchRequest = request.toRequest();
                          if (fetchRequest === undefined) {
                              throw new Error('Empty batch');
                          }
                          payloads = request.getEvents().map(function (event) { return event.getPayload(); });
                          _a.label = 1;
                      case 1:
                          _a.trys.push([1, 4, , 5]);
                          return [4 /*yield*/, customFetch(fetchRequest)];
                      case 2:
                          response = _a.sent();
                          return [4 /*yield*/, response.text()];
                      case 3:
                          _a.sent(); // wait for the response to be fully read
                          request.closeRequest(true);
                          if (response.ok) {
                              callOnRequestSuccess(payloads, response);
                              return [2 /*return*/, { success: true, retry: false, status: response.status }];
                          }
                          else {
                              willRetry = shouldRetryForStatusCode(response.status);
                              callOnRequestFailure({
                                  events: payloads,
                                  status: response.status,
                                  message: response.statusText,
                                  willRetry: willRetry,
                              }, response);
                              return [2 /*return*/, { success: false, retry: willRetry, status: response.status }];
                          }
                      case 4:
                          e_1 = _a.sent();
                          request.closeRequest(false);
                          message = typeof e_1 === 'string' ? e_1 : e_1 ? e_1.message : 'Unknown error';
                          callOnRequestFailure({
                              events: payloads,
                              message: message,
                              willRetry: true,
                          });
                          return [2 /*return*/, { success: false, retry: true }];
                      case 5: return [2 /*return*/];
                  }
              });
          });
      }
      function newEmitterRequestWithConfig() {
          return newEmitterRequest({
              endpoint: endpoint,
              protocol: protocol,
              port: port,
              eventMethod: eventMethod,
              customHeaders: customHeaders,
              connectionTimeout: connectionTimeout,
              keepalive: keepalive,
              maxPostBytes: maxPostBytes,
              useStm: useStm,
              credentials: credentials,
              postPath: postPath,
          });
      }
      function shouldSkipEventStore(emitterEvent) {
          var eventTooBigWarning = function (bytes, maxBytes) {
              return LOG.warn('Event (' + bytes + 'B) too big, max is ' + maxBytes);
          };
          if (usePost) {
              var bytes = emitterEvent.getPOSTRequestBytesCount() + 88; // 88 bytes for the payload_data envelope
              var tooBig = bytes > maxPostBytes;
              if (tooBig) {
                  eventTooBigWarning(bytes, maxPostBytes);
              }
              return tooBig;
          }
          else {
              if (maxGetBytes === undefined) {
                  return false;
              }
              var bytes = emitterEvent.getGETRequestBytesCount();
              var tooBig = bytes > maxGetBytes;
              if (tooBig) {
                  eventTooBigWarning(bytes, maxGetBytes);
              }
              return tooBig;
          }
      }
      function callCookieExtensionService() {
          return __awaiter(this, void 0, void 0, function () {
              var request;
              return __generator(this, function (_a) {
                  switch (_a.label) {
                      case 0:
                          if (!(cookieExtensionService && !cookieExtensionServiceCalled)) return [3 /*break*/, 2];
                          cookieExtensionServiceCalled = true;
                          request = new Request(cookieExtensionService, { method: 'GET' });
                          return [4 /*yield*/, customFetch(request)];
                      case 1:
                          _a.sent();
                          _a.label = 2;
                      case 2: return [2 /*return*/];
                  }
              });
          });
      }
      function flush() {
          return __awaiter(this, void 0, void 0, function () {
              var e_2;
              return __generator(this, function (_a) {
                  switch (_a.label) {
                      case 0:
                          if (!!flushInProgress) return [3 /*break*/, 5];
                          flushInProgress = true;
                          _a.label = 1;
                      case 1:
                          _a.trys.push([1, 3, 4, 5]);
                          return [4 /*yield*/, continueFlush()];
                      case 2:
                          _a.sent();
                          return [3 /*break*/, 5];
                      case 3:
                          e_2 = _a.sent();
                          LOG.error('Error sending events', e_2);
                          return [3 /*break*/, 5];
                      case 4:
                          flushInProgress = false;
                          return [7 /*endfinally*/];
                      case 5: return [2 /*return*/];
                  }
              });
          });
      }
      function continueFlush() {
          return __awaiter(this, void 0, void 0, function () {
              var request, eventStoreIterator, _a, value, done, event_1, _b, success, retry, status;
              return __generator(this, function (_c) {
                  switch (_c.label) {
                      case 0: return [4 /*yield*/, callCookieExtensionService()];
                      case 1:
                          _c.sent();
                          request = newEmitterRequestWithConfig();
                          eventStoreIterator = eventStore.iterator();
                          _c.label = 2;
                      case 2:
                          if (request.isFull()) {
                              return [3 /*break*/, 4];
                          }
                          return [4 /*yield*/, eventStoreIterator.next()];
                      case 3:
                          _a = _c.sent(), value = _a.value, done = _a.done;
                          if (done || value === undefined) {
                              return [3 /*break*/, 4];
                          }
                          event_1 = newEmitterEvent(value);
                          if (!request.addEvent(event_1)) {
                              return [3 /*break*/, 4];
                          }
                          return [3 /*break*/, 2];
                      case 4:
                          if (request.countEvents() === 0) {
                              return [2 /*return*/];
                          }
                          return [4 /*yield*/, executeRequest(request)];
                      case 5:
                          _b = _c.sent(), success = _b.success, retry = _b.retry, status = _b.status;
                          if (!(success || !retry)) return [3 /*break*/, 7];
                          if (!success) {
                              LOG.error("Status ".concat(status, ", will not retry."));
                          }
                          return [4 /*yield*/, eventStore.removeHead(request.countEvents())];
                      case 6:
                          _c.sent();
                          _c.label = 7;
                      case 7:
                          if (!success) return [3 /*break*/, 9];
                          return [4 /*yield*/, continueFlush()];
                      case 8:
                          _c.sent();
                          _c.label = 9;
                      case 9: return [2 /*return*/];
                  }
              });
          });
      }
      function input(payload) {
          return __awaiter(this, void 0, void 0, function () {
              var eventStorePayload, event, request, count;
              return __generator(this, function (_a) {
                  switch (_a.label) {
                      case 0:
                          eventStorePayload = newEventStorePayload({ payload: payload, svrAnon: serverAnonymization });
                          event = newEmitterEvent(eventStorePayload);
                          if (!shouldSkipEventStore(event)) return [3 /*break*/, 2];
                          request = newEmitterRequestWithConfig();
                          request.addEvent(event);
                          return [4 /*yield*/, executeRequest(request)];
                      case 1:
                          _a.sent();
                          return [3 /*break*/, 5];
                      case 2: return [4 /*yield*/, eventStore.add(eventStorePayload)];
                      case 3:
                          count = _a.sent();
                          if (!(count >= bufferSize)) return [3 /*break*/, 5];
                          return [4 /*yield*/, flush()];
                      case 4:
                          _a.sent();
                          _a.label = 5;
                      case 5: return [2 /*return*/];
                  }
              });
          });
      }
      function setCollectorUrl(url) {
          endpoint = url;
      }
      function setAnonymousTracking(at) {
          serverAnonymization = at;
      }
      function setBufferSize(bs) {
          bufferSize = bs;
      }
      return {
          flush: flush,
          input: input,
          setCollectorUrl: setCollectorUrl,
          setAnonymousTracking: setAnonymousTracking,
          setBufferSize: setBufferSize,
      };
  }

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  var version = version$1;

  var sha1 = {exports: {}};

  var crypt = {exports: {}};

  (function() {
    var base64map
        = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/',

    crypt$1 = {
      // Bit-wise rotation left
      rotl: function(n, b) {
        return (n << b) | (n >>> (32 - b));
      },

      // Bit-wise rotation right
      rotr: function(n, b) {
        return (n << (32 - b)) | (n >>> b);
      },

      // Swap big-endian to little-endian and vice versa
      endian: function(n) {
        // If number given, swap endian
        if (n.constructor == Number) {
          return crypt$1.rotl(n, 8) & 0x00FF00FF | crypt$1.rotl(n, 24) & 0xFF00FF00;
        }

        // Else, assume array and swap all items
        for (var i = 0; i < n.length; i++)
          n[i] = crypt$1.endian(n[i]);
        return n;
      },

      // Generate an array of any length of random bytes
      randomBytes: function(n) {
        for (var bytes = []; n > 0; n--)
          bytes.push(Math.floor(Math.random() * 256));
        return bytes;
      },

      // Convert a byte array to big-endian 32-bit words
      bytesToWords: function(bytes) {
        for (var words = [], i = 0, b = 0; i < bytes.length; i++, b += 8)
          words[b >>> 5] |= bytes[i] << (24 - b % 32);
        return words;
      },

      // Convert big-endian 32-bit words to a byte array
      wordsToBytes: function(words) {
        for (var bytes = [], b = 0; b < words.length * 32; b += 8)
          bytes.push((words[b >>> 5] >>> (24 - b % 32)) & 0xFF);
        return bytes;
      },

      // Convert a byte array to a hex string
      bytesToHex: function(bytes) {
        for (var hex = [], i = 0; i < bytes.length; i++) {
          hex.push((bytes[i] >>> 4).toString(16));
          hex.push((bytes[i] & 0xF).toString(16));
        }
        return hex.join('');
      },

      // Convert a hex string to a byte array
      hexToBytes: function(hex) {
        for (var bytes = [], c = 0; c < hex.length; c += 2)
          bytes.push(parseInt(hex.substr(c, 2), 16));
        return bytes;
      },

      // Convert a byte array to a base-64 string
      bytesToBase64: function(bytes) {
        for (var base64 = [], i = 0; i < bytes.length; i += 3) {
          var triplet = (bytes[i] << 16) | (bytes[i + 1] << 8) | bytes[i + 2];
          for (var j = 0; j < 4; j++)
            if (i * 8 + j * 6 <= bytes.length * 8)
              base64.push(base64map.charAt((triplet >>> 6 * (3 - j)) & 0x3F));
            else
              base64.push('=');
        }
        return base64.join('');
      },

      // Convert a base-64 string to a byte array
      base64ToBytes: function(base64) {
        // Remove non-base-64 characters
        base64 = base64.replace(/[^A-Z0-9+\/]/ig, '');

        for (var bytes = [], i = 0, imod4 = 0; i < base64.length;
            imod4 = ++i % 4) {
          if (imod4 == 0) continue;
          bytes.push(((base64map.indexOf(base64.charAt(i - 1))
              & (Math.pow(2, -2 * imod4 + 8) - 1)) << (imod4 * 2))
              | (base64map.indexOf(base64.charAt(i)) >>> (6 - imod4 * 2)));
        }
        return bytes;
      }
    };

    crypt.exports = crypt$1;
  })();

  var charenc = {
    // UTF-8 encoding
    utf8: {
      // Convert a string to a byte array
      stringToBytes: function(str) {
        return charenc.bin.stringToBytes(unescape(encodeURIComponent(str)));
      },

      // Convert a byte array to a string
      bytesToString: function(bytes) {
        return decodeURIComponent(escape(charenc.bin.bytesToString(bytes)));
      }
    },

    // Binary encoding
    bin: {
      // Convert a string to a byte array
      stringToBytes: function(str) {
        for (var bytes = [], i = 0; i < str.length; i++)
          bytes.push(str.charCodeAt(i) & 0xFF);
        return bytes;
      },

      // Convert a byte array to a string
      bytesToString: function(bytes) {
        for (var str = [], i = 0; i < bytes.length; i++)
          str.push(String.fromCharCode(bytes[i]));
        return str.join('');
      }
    }
  };

  var charenc_1 = charenc;

  (function() {
    var crypt$1 = crypt.exports,
        utf8 = charenc_1.utf8,
        bin = charenc_1.bin,

    // The core
    sha1$1 = function (message) {
      // Convert to byte array
      if (message.constructor == String)
        message = utf8.stringToBytes(message);
      else if (typeof Buffer !== 'undefined' && typeof Buffer.isBuffer == 'function' && Buffer.isBuffer(message))
        message = Array.prototype.slice.call(message, 0);
      else if (!Array.isArray(message))
        message = message.toString();

      // otherwise assume byte array

      var m  = crypt$1.bytesToWords(message),
          l  = message.length * 8,
          w  = [],
          H0 =  1732584193,
          H1 = -271733879,
          H2 = -1732584194,
          H3 =  271733878,
          H4 = -1009589776;

      // Padding
      m[l >> 5] |= 0x80 << (24 - l % 32);
      m[((l + 64 >>> 9) << 4) + 15] = l;

      for (var i = 0; i < m.length; i += 16) {
        var a = H0,
            b = H1,
            c = H2,
            d = H3,
            e = H4;

        for (var j = 0; j < 80; j++) {

          if (j < 16)
            w[j] = m[i + j];
          else {
            var n = w[j - 3] ^ w[j - 8] ^ w[j - 14] ^ w[j - 16];
            w[j] = (n << 1) | (n >>> 31);
          }

          var t = ((H0 << 5) | (H0 >>> 27)) + H4 + (w[j] >>> 0) + (
                  j < 20 ? (H1 & H2 | ~H1 & H3) + 1518500249 :
                  j < 40 ? (H1 ^ H2 ^ H3) + 1859775393 :
                  j < 60 ? (H1 & H2 | H1 & H3 | H2 & H3) - 1894007588 :
                           (H1 ^ H2 ^ H3) - 899497514);

          H4 = H3;
          H3 = H2;
          H2 = (H1 << 30) | (H1 >>> 2);
          H1 = H0;
          H0 = t;
        }

        H0 += a;
        H1 += b;
        H2 += c;
        H3 += d;
        H4 += e;
      }

      return [H0, H1, H2, H3, H4];
    },

    // Public API
    api = function (message, options) {
      var digestbytes = crypt$1.wordsToBytes(sha1$1(message));
      return options && options.asBytes ? digestbytes :
          options && options.asString ? bin.bytesToString(digestbytes) :
          crypt$1.bytesToHex(digestbytes);
    };

    api._blocksize = 16;
    api._digestsize = 20;

    sha1.exports = api;
  })();

  var hash = sha1.exports;

  /*!
   * Core functionality for Snowplow Browser trackers v4.6.2 (http://bit.ly/sp-js)
   * Copyright 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * Licensed under BSD-3-Clause
   */

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  /**
   * Attempt to get a value from localStorage
   *
   * @param string - key
   * @returns string The value obtained from localStorage, or
   *                undefined if localStorage is inaccessible
   */
  function attemptGetLocalStorage(key) {
      try {
          var localStorageAlias = window.localStorage, exp = localStorageAlias.getItem(key + '.expires');
          if (exp === null || +exp > Date.now()) {
              return localStorageAlias.getItem(key);
          }
          else {
              localStorageAlias.removeItem(key);
              localStorageAlias.removeItem(key + '.expires');
          }
          return undefined;
      }
      catch (e) {
          return undefined;
      }
  }
  /**
   * Attempt to write a value to localStorage
   *
   * @param string - key
   * @param string - value
   * @param number - ttl Time to live in seconds, defaults to 2 years from Date.now()
   * @returns boolean Whether the operation succeeded
   */
  function attemptWriteLocalStorage(key, value, ttl) {
      if (ttl === void 0) { ttl = 63072000; }
      try {
          var localStorageAlias = window.localStorage, t = Date.now() + ttl * 1000;
          localStorageAlias.setItem("".concat(key, ".expires"), t.toString());
          localStorageAlias.setItem(key, value);
          return true;
      }
      catch (e) {
          return false;
      }
  }
  /**
   * Attempt to delete a value from localStorage
   *
   * @param string - key
   * @returns boolean Whether the operation succeeded
   */
  function attemptDeleteLocalStorage(key) {
      try {
          var localStorageAlias = window.localStorage;
          localStorageAlias.removeItem(key);
          localStorageAlias.removeItem(key + '.expires');
          return true;
      }
      catch (e) {
          return false;
      }
  }
  /**
   * Attempt to get a value from sessionStorage
   *
   * @param string - key
   * @returns string The value obtained from sessionStorage, or
   *                undefined if sessionStorage is inaccessible
   */
  function attemptGetSessionStorage(key) {
      try {
          return window.sessionStorage.getItem(key);
      }
      catch (e) {
          return undefined;
      }
  }
  /**
   * Attempt to write a value to sessionStorage
   *
   * @param string - key
   * @param string - value
   * @returns boolean Whether the operation succeeded
   */
  function attemptWriteSessionStorage(key, value) {
      try {
          window.sessionStorage.setItem(key, value);
          return true;
      }
      catch (e) {
          return false;
      }
  }

  var DEFAULT_CROSS_DOMAIN_LINKER_PARAMS = {
      sessionId: true,
      sourceId: true,
      sourcePlatform: false,
      userId: false,
      reason: false,
  };
  function createCrossDomainParameterValue(isExtendedFormat, attributeConfiguration, attributeValues) {
      var _a;
      var crossDomainParameterValue;
      var timestamp = new Date().getTime();
      var config = __assign(__assign({}, DEFAULT_CROSS_DOMAIN_LINKER_PARAMS), attributeConfiguration);
      var domainUserId = attributeValues.domainUserId, userId = attributeValues.userId, sessionId = attributeValues.sessionId, sourceId = attributeValues.sourceId, sourcePlatform = attributeValues.sourcePlatform, event = attributeValues.event;
      var eventTarget = event.currentTarget;
      var reason = typeof config.reason === 'function' ? config.reason(event) : (_a = eventTarget === null || eventTarget === void 0 ? void 0 : eventTarget.textContent) === null || _a === void 0 ? void 0 : _a.trim();
      if (isExtendedFormat) {
          /* Index is used by Enrich, so it should not be changed. */
          crossDomainParameterValue = [
              domainUserId,
              timestamp,
              config.sessionId && sessionId,
              config.userId && urlSafeBase64Encode(userId || ''),
              config.sourceId && urlSafeBase64Encode(sourceId || ''),
              config.sourcePlatform && sourcePlatform,
              config.reason && urlSafeBase64Encode(reason || ''),
          ]
              .map(function (attribute) { return attribute || ''; })
              .join('.')
              // Remove trailing dots
              .replace(/([.]*$)/, '');
      }
      else {
          crossDomainParameterValue = attributeValues.domainUserId + '.' + timestamp;
      }
      return crossDomainParameterValue;
  }
  /**
   *
   * The url-safe variation emits - and _ instead of + and / characters. Also removes = sign padding.
   * @param {string} str The string to encode in a URL safe manner
   * @return {string}
   */
  function urlSafeBase64Encode(str) {
      return btoa(str).replace(/\+/g, '-').replace(/\//g, '_').replace(/\=+$/, '');
  }

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  /**
   * Checks if an object is a string
   * @param str - The object to check
   */
  function isString(str) {
      if (str && typeof str.valueOf() === 'string') {
          return true;
      }
      return false;
  }
  /**
   * Checks if an object is an integer
   * @param int - The object to check
   */
  function isInteger(int) {
      return ((Number.isInteger && Number.isInteger(int)) || (typeof int === 'number' && isFinite(int) && Math.floor(int) === int));
  }
  /**
   * Lightweight configured runtime timezone detection
   * @see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl/DateTimeFormat/resolvedOptions#getting_the_users_time_zone_and_locale_preferences
   * @returns IANA timezone name of current runtime preference
   */
  function getTimeZone() {
      if (typeof Intl === 'object' && typeof Intl.DateTimeFormat === 'function') {
          var systemPreferences = new Intl.DateTimeFormat().resolvedOptions();
          return systemPreferences.timeZone;
      }
  }
  /**
   * Cleans up the page title
   */
  function fixupTitle(title) {
      if (!isString(title)) {
          title = title.text || '';
          var tmp = document.getElementsByTagName('title');
          if (tmp && tmp[0] != null) {
              title = tmp[0].text;
          }
      }
      return title;
  }
  /**
   * Extract hostname from URL
   */
  function getHostName(url) {
      // scheme : // [username [: password] @] hostname [: port] [/ [path] [? query] [# fragment]]
      var e = new RegExp('^(?:(?:https?|ftp):)/*(?:[^@]+@)?([^:/#]+)'), matches = e.exec(url);
      return matches ? matches[1] : url;
  }
  /**
   * Fix-up domain
   */
  function fixupDomain(domain) {
      var dl = domain.length;
      // remove trailing '.'
      if (domain.charAt(--dl) === '.') {
          domain = domain.slice(0, dl);
      }
      // remove leading '*'
      if (domain.slice(0, 2) === '*.') {
          domain = domain.slice(1);
      }
      return domain;
  }
  /**
   * Get page referrer. In the case of a single-page app,
   * if the URL changes without the page reloading, pass
   * in the old URL. It will be returned unless overriden
   * by a "refer(r)er" parameter in the querystring.
   *
   * @param string - oldLocation Optional.
   * @returns string The referrer
   */
  function getReferrer(oldLocation) {
      var windowAlias = window, fromQs = fromQuerystring('referrer', windowAlias.location.href) || fromQuerystring('referer', windowAlias.location.href);
      // Short-circuit
      if (fromQs) {
          return fromQs;
      }
      // In the case of a single-page app, return the old URL
      if (oldLocation) {
          return oldLocation;
      }
      try {
          if (windowAlias.top) {
              return windowAlias.top.document.referrer;
          }
          else if (windowAlias.parent) {
              return windowAlias.parent.document.referrer;
          }
      }
      catch (_a) { }
      return document.referrer;
  }
  /**
   * Cross-browser helper function to add event handler
   */
  function addEventListener(element, eventType, eventHandler, options) {
      if (element.addEventListener) {
          element.addEventListener(eventType, eventHandler, options);
          return true;
      }
      // IE Support
      if (element.attachEvent) {
          return element.attachEvent('on' + eventType, eventHandler);
      }
      element['on' + eventType] = eventHandler;
  }
  /**
   * Return value from name-value pair in querystring
   */
  function fromQuerystring(field, url) {
      var match = new RegExp('^[^#]*[?&]' + field + '=([^&#]*)').exec(url);
      if (!match) {
          return null;
      }
      return decodeURIComponent(match[1].replace(/\+/g, ' '));
  }
  /**
   * Add a name-value pair to the querystring of a URL
   *
   * @param string - url URL to decorate
   * @param string - name Name of the querystring pair
   * @param string - value Value of the querystring pair
   */
  function decorateQuerystring(url, name, value) {
      var initialQsParams = name + '=' + value;
      var hashSplit = url.split('#');
      var qsSplit = hashSplit[0].split('?');
      var beforeQuerystring = qsSplit.shift();
      // Necessary because a querystring may contain multiple question marks
      var querystring = qsSplit.join('?');
      if (!querystring) {
          querystring = initialQsParams;
      }
      else {
          // Whether this is the first time the link has been decorated
          var initialDecoration = true;
          var qsFields = querystring.split('&');
          for (var i = 0; i < qsFields.length; i++) {
              if (qsFields[i].substr(0, name.length + 1) === name + '=') {
                  initialDecoration = false;
                  qsFields[i] = initialQsParams;
                  querystring = qsFields.join('&');
                  break;
              }
          }
          if (initialDecoration) {
              querystring = initialQsParams + '&' + querystring;
          }
      }
      hashSplit[0] = beforeQuerystring + '?' + querystring;
      return hashSplit.join('#');
  }
  /**
   * Finds the root domain
   */
  function findRootDomain(sameSite, secure) {
      var windowLocationHostnameAlias = window.location.hostname, cookiePrefix = '_sp_root_domain_test_', cookieName = cookiePrefix + new Date().getTime(), cookieValue = '_test_value_' + new Date().getTime();
      var locationParts = windowLocationHostnameAlias.split('.');
      for (var idx = locationParts.length - 2; idx >= 0; idx--) {
          var currentDomain = locationParts.slice(idx).join('.');
          cookie(cookieName, cookieValue, 0, '/', currentDomain, sameSite, secure);
          if (cookie(cookieName) === cookieValue) {
              // Clean up created cookie(s)
              deleteCookie(cookieName, '/', currentDomain, sameSite, secure);
              var cookieNames = getCookiesWithPrefix(cookiePrefix);
              for (var i = 0; i < cookieNames.length; i++) {
                  deleteCookie(cookieNames[i], '/', currentDomain, sameSite, secure);
              }
              return currentDomain;
          }
      }
      // Cookies cannot be read
      return windowLocationHostnameAlias;
  }
  /**
   * Deletes an arbitrary cookie by setting the expiration date to the past
   *
   * @param cookieName - The name of the cookie to delete
   * @param domainName - The domain the cookie is in
   */
  function deleteCookie(cookieName, path, domainName, sameSite, secure) {
      cookie(cookieName, '', -1, path, domainName, sameSite, secure);
  }
  /**
   * Fetches the name of all cookies beginning with a certain prefix
   *
   * @param cookiePrefix - The prefix to check for
   * @returns array The cookies that begin with the prefix
   */
  function getCookiesWithPrefix(cookiePrefix) {
      var cookies = document.cookie.split('; ');
      var cookieNames = [];
      for (var i = 0; i < cookies.length; i++) {
          if (cookies[i].substring(0, cookiePrefix.length) === cookiePrefix) {
              cookieNames.push(cookies[i]);
          }
      }
      return cookieNames;
  }
  /**
   * Get and set the cookies associated with the current document in browser
   * This implementation always returns a string, returns the cookie value if only name is specified
   *
   * @param name - The cookie name (required)
   * @param value - The cookie value
   * @param ttl - The cookie Time To Live (seconds)
   * @param path - The cookies path
   * @param domain - The cookies domain
   * @param samesite - The cookies samesite attribute
   * @param secure - Boolean to specify if cookie should be secure
   * @returns string The cookies value
   */
  function cookie(name, value, ttl, path, domain, samesite, secure) {
      if (arguments.length > 1) {
          return (document.cookie =
              name +
                  '=' +
                  encodeURIComponent(value !== null && value !== void 0 ? value : '') +
                  (ttl ? '; Expires=' + new Date(+new Date() + ttl * 1000).toUTCString() : '') +
                  (path ? '; Path=' + path : '') +
                  (domain ? '; Domain=' + domain : '') +
                  (samesite ? '; SameSite=' + samesite : '') +
                  (secure ? '; Secure' : ''));
      }
      return decodeURIComponent((('; ' + document.cookie).split('; ' + name + '=')[1] || '').split(';')[0]);
  }

  function newLocalStorageEventStore(_a) {
      var trackerId = _a.trackerId, _b = _a.maxLocalStorageQueueSize, maxLocalStorageQueueSize = _b === void 0 ? 1000 : _b, _c = _a.useLocalStorage, useLocalStorage = _c === void 0 ? true : _c;
      var queueName = "snowplowOutQueue_".concat(trackerId);
      function newInMemoryEventStoreFromLocalStorage() {
          if (useLocalStorage) {
              var localStorageQueue = window.localStorage.getItem(queueName);
              var events = localStorageQueue ? JSON.parse(localStorageQueue) : [];
              return newInMemoryEventStore({ maxSize: maxLocalStorageQueueSize, events: events });
          }
          else {
              return newInMemoryEventStore({ maxSize: maxLocalStorageQueueSize });
          }
      }
      var _d = newInMemoryEventStoreFromLocalStorage(), getAll = _d.getAll, getAllPayloads = _d.getAllPayloads, add = _d.add, count = _d.count, iterator = _d.iterator, removeHead = _d.removeHead;
      function sync() {
          if (useLocalStorage) {
              return getAll().then(function (events) {
                  window.localStorage.setItem(queueName, JSON.stringify(events));
              });
          }
          else {
              return Promise.resolve();
          }
      }
      return {
          count: count,
          add: function (payload) {
              add(payload);
              return sync().then(count);
          },
          removeHead: function (count) {
              removeHead(count);
              return sync();
          },
          iterator: iterator,
          getAll: getAll,
          getAllPayloads: getAllPayloads,
          setUseLocalStorage: function (use) {
              useLocalStorage = use;
          },
      };
  }

  function newOutQueue(configuration, sharedState) {
      var _a;
      var eventStore = (_a = configuration.eventStore) !== null && _a !== void 0 ? _a : newLocalStorageEventStore(configuration);
      configuration.eventStore = eventStore;
      var emitter = newEmitter(configuration);
      sharedState.bufferFlushers.push(emitter.flush);
      return {
          enqueueRequest: emitter.input,
          executeQueue: emitter.flush,
          setAnonymousTracking: emitter.setAnonymousTracking,
          setCollectorUrl: emitter.setCollectorUrl,
          setBufferSize: emitter.setBufferSize,
          setUseLocalStorage: function (localStorage) {
              if (eventStore.hasOwnProperty('setUseLocalStorage')) {
                  var localStorageStore = eventStore;
                  localStorageStore.setUseLocalStorage(localStorage);
              }
          },
      };
  }

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  /*
   * Extract parameter from URL
   */
  function getParameter(url, name) {
      // scheme : // [username [: password] @] hostname [: port] [/ [path] [? query] [# fragment]]
      var e = new RegExp('^(?:https?|ftp)(?::/*(?:[^?]+))([?][^#]+)'), matches = e.exec(url);
      if (matches && (matches === null || matches === void 0 ? void 0 : matches.length) > 1) {
          return fromQuerystring(name, matches[1]);
      }
      return null;
  }
  /*
   * Fix-up URL when page rendered from search engine cache or translated page.
   */
  function fixupUrl(hostName, href, referrer) {
      var _a;
      if (hostName === 'translate.googleusercontent.com') {
          // Google
          if (referrer === '') {
              referrer = href;
          }
          href = (_a = getParameter(href, 'u')) !== null && _a !== void 0 ? _a : '';
          hostName = getHostName(href);
      }
      else if (hostName === 'cc.bingj.com' || // Bing & Yahoo
          hostName === 'webcache.googleusercontent.com' // Google
      ) {
          href = document.links[0].href;
          hostName = getHostName(href);
      }
      return [hostName, href, referrer];
  }

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  /**
   * Indices of cookie values
   */
  var cookieDisabledIndex = 0, domainUserIdIndex = 1, createTsIndex = 2, visitCountIndex = 3, nowTsIndex = 4, lastVisitTsIndex = 5, sessionIdIndex = 6, previousSessionIdIndex = 7, firstEventIdIndex = 8, firstEventTsInMsIndex = 9, eventIndexIndex = 10;
  function emptyIdCookie() {
      var idCookie = ['1', '', 0, 0, 0, undefined, '', '', '', undefined, 0];
      return idCookie;
  }
  /**
   * Parses the cookie values from its string representation.
   *
   * @param id Cookie value as string
   * @param domainUserId Domain user ID to be used in case of empty cookie string
   * @returns Parsed ID cookie tuple
   */
  function parseIdCookie(id, domainUserId, memorizedSessionId, memorizedVisitCount) {
      var now = new Date(), nowTs = Math.round(now.getTime() / 1000), tmpContainer;
      if (id) {
          tmpContainer = id.split('.');
          // cookies enabled
          tmpContainer.unshift('0');
      }
      else {
          tmpContainer = [
              // cookies disabled
              '1',
              // Domain user ID
              domainUserId,
              // Creation timestamp - seconds since Unix epoch
              nowTs,
              // visitCount - 0 = no previous visit
              memorizedVisitCount,
              // Current visit timestamp
              nowTs,
              // Last visit timestamp - blank meaning no previous visit
              '',
              // Session ID
              memorizedSessionId,
          ];
      }
      if (!tmpContainer[sessionIdIndex] || tmpContainer[sessionIdIndex] === 'undefined') {
          // session id
          tmpContainer[sessionIdIndex] = v4();
      }
      if (!tmpContainer[previousSessionIdIndex] || tmpContainer[previousSessionIdIndex] === 'undefined') {
          // previous session id
          tmpContainer[previousSessionIdIndex] = '';
      }
      if (!tmpContainer[firstEventIdIndex] || tmpContainer[firstEventIdIndex] === 'undefined') {
          // firstEventId - blank meaning no previous event
          tmpContainer[firstEventIdIndex] = '';
      }
      if (!tmpContainer[firstEventTsInMsIndex] || tmpContainer[firstEventTsInMsIndex] === 'undefined') {
          // firstEventTs - blank meaning no previous event
          tmpContainer[firstEventTsInMsIndex] = '';
      }
      if (!tmpContainer[eventIndexIndex] || tmpContainer[eventIndexIndex] === 'undefined') {
          // eventIndex – 0 = no previous event
          tmpContainer[eventIndexIndex] = 0;
      }
      var parseIntOr = function (value, defaultValue) {
          var parsed = parseInt(value);
          return isNaN(parsed) ? defaultValue : parsed;
      };
      var parseIntOrUndefined = function (value) { return (value ? parseIntOr(value, undefined) : undefined); };
      var parsed = [
          tmpContainer[cookieDisabledIndex],
          tmpContainer[domainUserIdIndex],
          parseIntOr(tmpContainer[createTsIndex], nowTs),
          parseIntOr(tmpContainer[visitCountIndex], memorizedVisitCount),
          parseIntOr(tmpContainer[nowTsIndex], nowTs),
          parseIntOrUndefined(tmpContainer[lastVisitTsIndex]),
          tmpContainer[sessionIdIndex],
          tmpContainer[previousSessionIdIndex],
          tmpContainer[firstEventIdIndex],
          parseIntOrUndefined(tmpContainer[firstEventTsInMsIndex]),
          parseIntOr(tmpContainer[eventIndexIndex], 0),
      ];
      return parsed;
  }
  /**
   * Initializes the domain user ID if not already present in the cookie. Sets an empty string if anonymous tracking.
   *
   * @param idCookie Parsed cookie
   * @param configAnonymousTracking Whether anonymous tracking is enabled
   * @returns Domain user ID
   */
  function initializeDomainUserId(idCookie, configAnonymousTracking) {
      var domainUserId;
      if (idCookie[domainUserIdIndex]) {
          domainUserId = idCookie[domainUserIdIndex];
      }
      else if (!configAnonymousTracking) {
          domainUserId = v4();
          idCookie[domainUserIdIndex] = domainUserId;
      }
      else {
          domainUserId = '';
          idCookie[domainUserIdIndex] = domainUserId;
      }
      return domainUserId;
  }
  /**
   * Starts a new session with a new ID.
   * Sets the previous session, last visit timestamp, and increments visit count if cookies enabled.
   * First event references are reset and will be updated in `updateFirstEventInIdCookie`.
   *
   * @param idCookie Parsed cookie
   * @param options.configStateStorageStrategy Cookie storage strategy
   * @param options.configAnonymousTracking If anonymous tracking is enabled
   * @param options.memorizedVisitCount Visit count to be used if cookies not enabled
   * @param options.onSessionUpdateCallback Session callback triggered on every session update
   * @returns New session ID
   */
  function startNewIdCookieSession(idCookie, options) {
      if (options === void 0) { options = { memorizedVisitCount: 1 }; }
      var memorizedVisitCount = options.memorizedVisitCount;
      // If cookies are enabled, base visit count and session ID on the cookies
      if (cookiesEnabledInIdCookie(idCookie)) {
          // Store the previous session ID
          idCookie[previousSessionIdIndex] = idCookie[sessionIdIndex];
          // Set lastVisitTs to currentVisitTs
          idCookie[lastVisitTsIndex] = idCookie[nowTsIndex];
          // Increment the session ID
          idCookie[visitCountIndex]++;
      }
      else {
          idCookie[visitCountIndex] = memorizedVisitCount;
      }
      // Create a new sessionId
      var sessionId = v4();
      idCookie[sessionIdIndex] = sessionId;
      // Reset event index and first event references
      idCookie[eventIndexIndex] = 0;
      idCookie[firstEventIdIndex] = '';
      idCookie[firstEventTsInMsIndex] = undefined;
      return sessionId;
  }
  /**
   * Update now timestamp in cookie.
   *
   * @param idCookie Parsed cookie
   */
  function updateNowTsInIdCookie(idCookie) {
      idCookie[nowTsIndex] = Math.round(new Date().getTime() / 1000);
  }
  /**
   * Updates the first event references according to the event payload if first event in session.
   *
   * @param idCookie - Parsed cookie
   * @param payloadBuilder - Event payload builder
   */
  function updateFirstEventInIdCookie(idCookie, payloadBuilder) {
      // Update first event references if new session or not present
      if (idCookie[eventIndexIndex] === 0) {
          var payload = payloadBuilder.build();
          idCookie[firstEventIdIndex] = payload['eid'];
          var ts = (payload['dtm'] || payload['ttm']);
          idCookie[firstEventTsInMsIndex] = ts ? parseInt(ts) : undefined;
      }
  }
  /**
   * Increments event index counter.
   *
   * @param idCookie Parsed cookie
   */
  function incrementEventIndexInIdCookie(idCookie) {
      idCookie[eventIndexIndex] += 1;
  }
  /**
   * Serializes parsed cookie to string representation.
   *
   * @param idCookie Parsed cookie
   * @returns String cookie value
   */
  function serializeIdCookie(idCookie, configAnonymousTracking) {
      var anonymizedIdCookie = __spreadArray([], idCookie, true);
      if (configAnonymousTracking) {
          anonymizedIdCookie[domainUserIdIndex] = '';
          anonymizedIdCookie[previousSessionIdIndex] = '';
      }
      anonymizedIdCookie.shift();
      return anonymizedIdCookie.join('.');
  }
  /**
   * Transforms the parsed cookie into a client session context entity.
   *
   * @param idCookie Parsed cookie
   * @param configStateStorageStrategy Cookie storage strategy
   * @param configAnonymousTracking If anonymous tracking is enabled
   * @returns Client session context entity
   */
  function clientSessionFromIdCookie(idCookie, configStateStorageStrategy, configAnonymousTracking) {
      var firstEventTsInMs = idCookie[firstEventTsInMsIndex];
      var clientSession = {
          userId: configAnonymousTracking
              ? '00000000-0000-0000-0000-000000000000' // TODO: use uuid.NIL when we upgrade to uuid v8.3
              : idCookie[domainUserIdIndex],
          sessionId: idCookie[sessionIdIndex],
          eventIndex: idCookie[eventIndexIndex],
          sessionIndex: idCookie[visitCountIndex],
          previousSessionId: configAnonymousTracking ? null : idCookie[previousSessionIdIndex] || null,
          storageMechanism: configStateStorageStrategy == 'localStorage' ? 'LOCAL_STORAGE' : 'COOKIE_1',
          firstEventId: idCookie[firstEventIdIndex] || null,
          firstEventTimestamp: firstEventTsInMs ? new Date(firstEventTsInMs).toISOString() : null,
      };
      return clientSession;
  }
  function sessionIdFromIdCookie(idCookie) {
      return idCookie[sessionIdIndex];
  }
  function domainUserIdFromIdCookie(idCookie) {
      return idCookie[domainUserIdIndex];
  }
  function visitCountFromIdCookie(idCookie) {
      return idCookie[visitCountIndex];
  }
  function cookiesEnabledInIdCookie(idCookie) {
      return idCookie[cookieDisabledIndex] === '0';
  }
  function eventIndexFromIdCookie(idCookie) {
      return idCookie[eventIndexIndex];
  }

  var WEB_PAGE_SCHEMA = 'iglu:com.snowplowanalytics.snowplow/web_page/jsonschema/1-0-0';
  var BROWSER_CONTEXT_SCHEMA = 'iglu:com.snowplowanalytics.snowplow/browser_context/jsonschema/2-0-0';
  var CLIENT_SESSION_SCHEMA = 'iglu:com.snowplowanalytics.snowplow/client_session/jsonschema/1-0-2';
  var APPLICATION_CONTEXT_SCHEMA = 'iglu:com.snowplowanalytics.snowplow/application/jsonschema/1-0-0';

  function useResizeObserver() {
      return 'ResizeObserver' in window;
  }
  var resizeObserverInitialized = false;
  var readBrowserPropertiesTask = null;
  function initializeResizeObserver() {
      if (resizeObserverInitialized) {
          return;
      }
      if (!document || !document.body || !document.documentElement) {
          return;
      }
      resizeObserverInitialized = true;
      var resizeObserver = new ResizeObserver(function () {
          if (!readBrowserPropertiesTask) {
              // The browser property lookup causes a forced synchronous layout when offsets/sizes are
              // queried. It's possible that the forced synchronous layout causes the ResizeObserver
              // to be fired again, leading to an infinite loop and the "ResizeObserver loop completed
              // with undelivered notifications" error.
              readBrowserPropertiesTask = requestAnimationFrame(function () {
                  readBrowserPropertiesTask = null;
                  cachedProperties = readBrowserProperties();
              });
          }
      });
      resizeObserver.observe(document.body);
      resizeObserver.observe(document.documentElement);
  }
  var cachedProperties;
  /* Separator used for dimension values e.g. widthxheight */
  var DIMENSION_SEPARATOR = 'x';
  /**
   * Gets various browser properties (that are expensive to read!)
   * - Will use a "ResizeObserver" approach in modern browsers to update cached properties only on change
   * - Will fallback to a direct read approach without cache in old browsers
   *
   * @returns BrowserProperties
   */
  function getBrowserProperties() {
      if (!useResizeObserver()) {
          return readBrowserProperties();
      }
      if (!cachedProperties) {
          cachedProperties = readBrowserProperties();
      }
      initializeResizeObserver();
      return cachedProperties;
  }
  /**
   * Reads the browser properties - expensive call!
   *
   * @returns BrowserProperties
   */
  function readBrowserProperties() {
      return {
          viewport: floorDimensionFields(detectViewport()),
          documentSize: floorDimensionFields(detectDocumentSize()),
          resolution: floorDimensionFields(detectScreenResolution()),
          colorDepth: screen.colorDepth,
          devicePixelRatio: window.devicePixelRatio,
          cookiesEnabled: window.navigator.cookieEnabled,
          online: window.navigator.onLine,
          browserLanguage: window.navigator.language || window.navigator.userLanguage,
          documentLanguage: document.documentElement.lang,
          webdriver: window.navigator.webdriver,
          deviceMemory: window.navigator.deviceMemory,
          hardwareConcurrency: window.navigator.hardwareConcurrency,
      };
  }
  /**
   * Gets the current viewport.
   *
   * Code based on:
   * - http://andylangton.co.uk/articles/javascript/get-viewport-size-javascript/
   * - http://responsejs.com/labs/dimensions/
   */
  function detectViewport() {
      var width, height;
      if ('innerWidth' in window) {
          width = window['innerWidth'];
          height = window['innerHeight'];
      }
      else {
          var e = document.documentElement || document.body;
          width = e['clientWidth'];
          height = e['clientHeight'];
      }
      return Math.max(0, width) + DIMENSION_SEPARATOR + Math.max(0, height);
  }
  /**
   * Gets the dimensions of the current
   * document.
   *
   * Code based on:
   * - http://andylangton.co.uk/articles/javascript/get-viewport-size-javascript/
   */
  function detectDocumentSize() {
      var de = document.documentElement, // Alias
      be = document.body, 
      // document.body may not have rendered, so check whether be.offsetHeight is null
      bodyHeight = be ? Math.max(be.offsetHeight, be.scrollHeight) : 0;
      var w = Math.max(de.clientWidth, de.offsetWidth, de.scrollWidth);
      var h = Math.max(de.clientHeight, de.offsetHeight, de.scrollHeight, bodyHeight);
      return isNaN(w) || isNaN(h) ? '' : w + DIMENSION_SEPARATOR + h;
  }
  function detectScreenResolution() {
      return screen.width + DIMENSION_SEPARATOR + screen.height;
  }
  function floorDimensionFields(field) {
      return (field &&
          field
              .split(DIMENSION_SEPARATOR)
              .map(function (dimension) { return Math.floor(Number(dimension)); })
              .join(DIMENSION_SEPARATOR));
  }

  function newCookie(name) {
      var flushTimer;
      var lastSetValueArgs;
      var cacheExpireAt;
      var flushed = true;
      var flushTimeout = 10; // milliseconds
      var maxCacheTtl = 0.05; // seconds
      function getValue() {
          var _a;
          // Note: we can't cache the cookie value as we don't know the expiration date
          if (lastSetValueArgs && (!cacheExpireAt || cacheExpireAt > new Date())) {
              return (_a = lastSetValueArgs[0]) !== null && _a !== void 0 ? _a : cookie(name);
          }
          return cookie(name);
      }
      function setValue(value, ttl, path, domain, samesite, secure) {
          lastSetValueArgs = [value, ttl, path, domain, samesite, secure];
          flushed = false;
          // throttle setting the cookie
          if (flushTimer === undefined) {
              flushTimer = setTimeout(function () {
                  flushTimer = undefined;
                  flush();
              }, flushTimeout);
          }
          cacheExpireAt = new Date(Date.now() + Math.min(maxCacheTtl, ttl !== null && ttl !== void 0 ? ttl : maxCacheTtl) * 1000);
          return true;
      }
      function deleteValue(path, domainName, sameSite, secure) {
          lastSetValueArgs = undefined;
          flushed = true;
          // cancel setting the cookie
          if (flushTimer !== undefined) {
              clearTimeout(flushTimer);
              flushTimer = undefined;
          }
          deleteCookie(name, path, domainName, sameSite, secure);
      }
      function flush() {
          if (flushTimer !== undefined) {
              clearTimeout(flushTimer);
              flushTimer = undefined;
          }
          if (flushed) {
              return;
          }
          flushed = true;
          if (lastSetValueArgs !== undefined) {
              var value = lastSetValueArgs[0], ttl = lastSetValueArgs[1], path = lastSetValueArgs[2], domain = lastSetValueArgs[3], samesite = lastSetValueArgs[4], secure = lastSetValueArgs[5];
              cookie(name, value, ttl, path, domain, samesite, secure);
          }
      }
      return {
          getValue: getValue,
          setValue: setValue,
          deleteValue: deleteValue,
          flush: flush,
      };
  }
  /**
   * Create a new async cookie storage
   *
   * @returns A new cookie storage
   */
  function newCookieStorage() {
      var cache = {};
      function getOrInitCookie(name) {
          if (!cache[name]) {
              cache[name] = newCookie(name);
          }
          return cache[name];
      }
      function getCookie(name) {
          return getOrInitCookie(name).getValue();
      }
      function setCookie(name, value, ttl, path, domain, samesite, secure) {
          return getOrInitCookie(name).setValue(value, ttl, path, domain, samesite, secure);
      }
      function deleteCookie(name, path, domainName, sameSite, secure) {
          getOrInitCookie(name).deleteValue(path, domainName, sameSite, secure);
      }
      function clearCache() {
          cache = {};
      }
      function flush() {
          for (var _i = 0, _a = Object.values(cache); _i < _a.length; _i++) {
              var cookie_1 = _a[_i];
              cookie_1.flush();
          }
      }
      return {
          getCookie: getCookie,
          setCookie: setCookie,
          deleteCookie: deleteCookie,
          clearCache: clearCache,
          flush: flush,
      };
  }
  /**
   * Cookie storage instance with asynchronous cookie writes
   */
  var asyncCookieStorage = newCookieStorage();
  /**
   * Cookie storage instance with synchronous cookie writes
   */
  var syncCookieStorage = {
      getCookie: cookie,
      setCookie: function (name, value, ttl, path, domain, samesite, secure) {
          cookie(name, value, ttl, path, domain, samesite, secure);
          return document.cookie.indexOf("".concat(name, "=")) !== -1;
      },
      deleteCookie: deleteCookie,
      flush: function () { },
  };

  /**
   * The Snowplow Tracker
   *
   * @param trackerId - The unique identifier of the tracker
   * @param namespace - The namespace of the tracker object
   * @param version - The current version of the JavaScript Tracker
   * @param endpoint - The collector endpoint to send events to, with or without protocol
   * @param sharedState - An object containing state which is shared across tracker instances
   * @param trackerConfiguration - Dictionary of configuration options
   */
  function Tracker(trackerId, namespace, version, endpoint, sharedState, trackerConfiguration) {
      if (trackerConfiguration === void 0) { trackerConfiguration = {}; }
      var browserPlugins = [];
      var newTracker = function (trackerId, namespace, version, endpoint, state, trackerConfiguration) {
          /************************************************************
           * Private members
           ************************************************************/
          var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v;
          //use POST if eventMethod isn't present on the newTrackerConfiguration
          trackerConfiguration.eventMethod = (_a = trackerConfiguration.eventMethod) !== null && _a !== void 0 ? _a : 'post';
          var getStateStorageStrategy = function (config) { var _a; return (_a = config.stateStorageStrategy) !== null && _a !== void 0 ? _a : 'cookieAndLocalStorage'; }, getAnonymousSessionTracking = function (config) {
              var _a;
              if (typeof config.anonymousTracking === 'boolean') {
                  return false;
              }
              return ((_a = config.anonymousTracking) === null || _a === void 0 ? void 0 : _a.withSessionTracking) === true;
          }, getAnonymousServerTracking = function (config) {
              var _a;
              if (typeof config.anonymousTracking === 'boolean') {
                  return false;
              }
              return ((_a = config.anonymousTracking) === null || _a === void 0 ? void 0 : _a.withServerAnonymisation) === true;
          }, getAnonymousTracking = function (config) { return !!config.anonymousTracking; }, isBrowserContextAvailable = (_c = (_b = trackerConfiguration === null || trackerConfiguration === void 0 ? void 0 : trackerConfiguration.contexts) === null || _b === void 0 ? void 0 : _b.browser) !== null && _c !== void 0 ? _c : false, isWebPageContextAvailable = (_e = (_d = trackerConfiguration === null || trackerConfiguration === void 0 ? void 0 : trackerConfiguration.contexts) === null || _d === void 0 ? void 0 : _d.webPage) !== null && _e !== void 0 ? _e : true, getExtendedCrossDomainTrackingConfiguration = function (crossDomainTrackingConfig) {
              if (typeof crossDomainTrackingConfig === 'boolean') {
                  return { useExtendedCrossDomainLinker: crossDomainTrackingConfig };
              }
              return {
                  useExtendedCrossDomainLinker: true,
                  collectCrossDomainAttributes: crossDomainTrackingConfig,
              };
          };
          // Create a new cookie storage instance with synchronous cookie write if configured
          var cookieStorage = trackerConfiguration.synchronousCookieWrite ? syncCookieStorage : asyncCookieStorage;
          // Get all injected plugins
          browserPlugins.push(getBrowserDataPlugin());
          /* When including the Web Page context, we add the relevant internal plugins */
          if (isWebPageContextAvailable) {
              browserPlugins.push(getWebPagePlugin());
          }
          if (isBrowserContextAvailable) {
              browserPlugins.push(getBrowserContextPlugin());
          }
          browserPlugins.push.apply(browserPlugins, ((_f = trackerConfiguration.plugins) !== null && _f !== void 0 ? _f : []));
          var // Tracker core
          core = trackerCore({
              base64: (_g = trackerConfiguration.encodeBase64) !== null && _g !== void 0 ? _g : trackerConfiguration.eventMethod !== 'post',
              corePlugins: browserPlugins,
              callback: sendRequest,
          }), 
          // Aliases
          documentCharset = document.characterSet || document.charset, 
          // Current URL and Referrer URL
          locationArray = fixupUrl(window.location.hostname, window.location.href, getReferrer()), domainAlias = fixupDomain(locationArray[0]), locationHrefAlias = locationArray[1], configReferrerUrl = locationArray[2], customReferrer, 
          // Platform defaults to web for this tracker
          configPlatform = (_h = trackerConfiguration.platform) !== null && _h !== void 0 ? _h : 'web', 
          // Site ID
          configTrackerSiteId = (_j = trackerConfiguration.appId) !== null && _j !== void 0 ? _j : '', 
          // Application version
          configAppVersion = trackerConfiguration.appVersion, 
          // Document URL
          configCustomUrl, 
          // Document title
          lastDocumentTitle = document.title, 
          // Custom title
          lastConfigTitle, 
          // Indicates that the lastConfigTitle was set from a trackPageView call
          // Custom title configured this way has a shorter lifespan than when set using setDocumentTitle.
          // It only lasts until the next trackPageView call.
          lastConfigTitleFromTrackPageView = false, 
          // Controls whether activity tracking page ping event timers are reset on page view events
          resetActivityTrackingOnPageView = (_k = trackerConfiguration.resetActivityTrackingOnPageView) !== null && _k !== void 0 ? _k : true, 
          // Disallow hash tags in URL. TODO: Should this be set to true by default?
          configDiscardHashTag, 
          // Disallow brace in URL.
          configDiscardBrace, 
          // First-party cookie name prefix
          configCookieNamePrefix = (_l = trackerConfiguration.cookieName) !== null && _l !== void 0 ? _l : '_sp_', 
          // First-party cookie domain
          // User agent defaults to origin hostname
          configCookieDomain = (_m = trackerConfiguration.cookieDomain) !== null && _m !== void 0 ? _m : undefined, discoverRootDomain = (_o = trackerConfiguration.discoverRootDomain) !== null && _o !== void 0 ? _o : configCookieDomain === undefined, 
          // First-party cookie path
          // Default is user agent defined.
          configCookiePath = '/', 
          // First-party cookie samesite attribute
          configCookieSameSite = (_p = trackerConfiguration.cookieSameSite) !== null && _p !== void 0 ? _p : 'Lax', 
          // First-party cookie secure attribute
          configCookieSecure = (_q = trackerConfiguration.cookieSecure) !== null && _q !== void 0 ? _q : true, 
          // Do Not Track browser feature
          dnt = window.navigator.doNotTrack || window.navigator.msDoNotTrack || window.doNotTrack, 
          // Do Not Track
          configDoNotTrack = typeof trackerConfiguration.respectDoNotTrack !== 'undefined'
              ? trackerConfiguration.respectDoNotTrack && (dnt === 'yes' || dnt === '1')
              : false, 
          // Opt out of cookie tracking
          configOptOutCookie, 
          // Life of the visitor cookie (in seconds)
          configVisitorCookieTimeout = (_r = trackerConfiguration.cookieLifetime) !== null && _r !== void 0 ? _r : 63072000, // 2 years
          // Life of the session cookie (in seconds)
          configSessionCookieTimeout = (_s = trackerConfiguration.sessionCookieTimeout) !== null && _s !== void 0 ? _s : 1800, // 30 minutes
          // Allows tracking user session (using cookies or local storage), can only be used with anonymousTracking
          configAnonymousSessionTracking = getAnonymousSessionTracking(trackerConfiguration), 
          // Will send a header to server to prevent returning cookie and capturing IP
          configAnonymousServerTracking = getAnonymousServerTracking(trackerConfiguration), 
          // Sets tracker to work in anonymous mode without accessing client storage
          configAnonymousTracking = getAnonymousTracking(trackerConfiguration), 
          // Strategy defining how to store the state: cookie, localStorage, cookieAndLocalStorage or none
          configStateStorageStrategy = getStateStorageStrategy(trackerConfiguration), 
          // Last activity timestamp
          lastActivityTime, 
          // The last time an event was fired on the page - used to invalidate session if cookies are disabled
          lastEventTime = new Date().getTime(), 
          // How are we scrolling?
          minXOffset, maxXOffset, minYOffset, maxYOffset, 
          // Domain hash value
          domainHash, 
          // Domain unique user ID
          domainUserId, 
          // ID for the current session
          memorizedSessionId, 
          // Index for the current session - kept in memory in case cookies are disabled
          memorizedVisitCount = 1, 
          // Business-defined unique user ID
          businessUserId, 
          // Manager for local storage queue
          outQueue = newOutQueue(__assign({ trackerId: trackerId, endpoint: asCollectorUrl(endpoint), serverAnonymization: configAnonymousServerTracking, useLocalStorage: configStateStorageStrategy == 'localStorage' || configStateStorageStrategy == 'cookieAndLocalStorage' }, trackerConfiguration), state), 
          // Whether pageViewId should be regenerated after each trackPageView. Affect web_page context
          preservePageViewId = false, 
          // Whether pageViewId should be kept the same until the page URL changes. Affects web_page context
          preservePageViewIdForUrl = (_t = trackerConfiguration.preservePageViewIdForUrl) !== null && _t !== void 0 ? _t : false, 
          // The pageViewId of the last page view event or undefined if no page view tracked yet. Used to determine if pageViewId should be regenerated for a new page view.
          lastSentPageViewId = undefined, 
          // Activity tracking config for callback and page ping variants
          activityTrackingConfig = {
              enabled: false,
              installed: false,
              configurations: {},
          }, configSessionContext = (_v = (_u = trackerConfiguration.contexts) === null || _u === void 0 ? void 0 : _u.session) !== null && _v !== void 0 ? _v : false, toOptoutByCookie, onSessionUpdateCallback = trackerConfiguration.onSessionUpdateCallback, manualSessionUpdateCalled = false, _w = getExtendedCrossDomainTrackingConfiguration(trackerConfiguration.useExtendedCrossDomainLinker || false), useExtendedCrossDomainLinker = _w.useExtendedCrossDomainLinker, collectCrossDomainAttributes = _w.collectCrossDomainAttributes;
          if (discoverRootDomain && !configCookieDomain) {
              configCookieDomain = findRootDomain(configCookieSameSite, configCookieSecure);
          }
          var _x = getBrowserProperties(), browserLanguage = _x.browserLanguage, resolution = _x.resolution, colorDepth = _x.colorDepth, cookiesEnabled = _x.cookiesEnabled;
          var timeZone = getTimeZone();
          // Set up unchanging name-value pairs
          core.setTrackerVersion(version);
          core.setTrackerNamespace(namespace);
          core.setAppId(configTrackerSiteId);
          core.setPlatform(configPlatform);
          core.addPayloadPair('cookie', cookiesEnabled ? '1' : '0');
          core.addPayloadPair('cs', documentCharset);
          core.addPayloadPair('lang', browserLanguage);
          core.addPayloadPair('res', resolution);
          core.addPayloadPair('cd', colorDepth);
          if (timeZone)
              core.addPayloadPair('tz', timeZone);
          // Add the application version context entity
          if (configAppVersion) {
              core.addPlugin({
                  plugin: {
                      contexts: function () { return [
                          {
                              schema: APPLICATION_CONTEXT_SCHEMA,
                              data: { version: configAppVersion },
                          },
                      ]; },
                  },
              });
          }
          /*
           * Initialize tracker
           */
          updateDomainHash();
          initializeIdsAndCookies();
          if (trackerConfiguration.crossDomainLinker) {
              decorateLinks(trackerConfiguration.crossDomainLinker);
          }
          /**
           * Recalculate the domain, URL, and referrer
           */
          function refreshUrl() {
              locationArray = fixupUrl(window.location.hostname, window.location.href, getReferrer());
              // If this is a single-page app and the page URL has changed, then:
              //   - if the new URL's querystring contains a "refer(r)er" parameter, use it as the referrer
              //   - otherwise use the old URL as the referer
              if (locationArray[1] !== locationHrefAlias) {
                  configReferrerUrl = getReferrer(locationHrefAlias);
              }
              domainAlias = fixupDomain(locationArray[0]);
              locationHrefAlias = locationArray[1];
          }
          /**
           * Create link handler to decorate the querystring of a link (onClick/onMouseDown)
           *
           * @param event - e The event targeting the link
           */
          function addLinkDecorationHandler(extended) {
              var CROSS_DOMAIN_PARAMETER_NAME = '_sp';
              return function (evt) {
                  var elt = evt.currentTarget;
                  var crossDomainParameterValue = createCrossDomainParameterValue(extended, collectCrossDomainAttributes, {
                      domainUserId: domainUserId,
                      userId: businessUserId || undefined,
                      sessionId: memorizedSessionId,
                      sourceId: configTrackerSiteId,
                      sourcePlatform: configPlatform,
                      event: evt,
                  });
                  if (elt === null || elt === void 0 ? void 0 : elt.href) {
                      elt.href = decorateQuerystring(elt.href, CROSS_DOMAIN_PARAMETER_NAME, crossDomainParameterValue);
                  }
              };
          }
          /**
           * Enable querystring decoration for links passing a filter
           * Whenever such a link is clicked on or navigated to via the keyboard,
           * add "_sp={{duid}}.{{timestamp}}" to its querystring
           *
           * @param crossDomainLinker - Function used to determine which links to decorate
           */
          function decorateLinks(crossDomainLinker) {
              var crossDomainLinkHandler = addLinkDecorationHandler(useExtendedCrossDomainLinker);
              for (var i = 0; i < document.links.length; i++) {
                  var elt = document.links[i];
                  if (!elt.spDecorationEnabled && crossDomainLinker(elt)) {
                      elt.addEventListener('click', crossDomainLinkHandler, true);
                      elt.addEventListener('mousedown', crossDomainLinkHandler, true);
                      // Don't add event listeners more than once
                      elt.spDecorationEnabled = true;
                  }
              }
          }
          /*
           * Removes hash tag from the URL
           *
           * URLs are purified before being recorded in the cookie,
           * or before being sent as GET parameters
           */
          function purify(url) {
              var targetPattern;
              if (configDiscardHashTag) {
                  targetPattern = new RegExp('#.*');
                  url = url.replace(targetPattern, '');
              }
              if (configDiscardBrace) {
                  targetPattern = new RegExp('[{}]', 'g');
                  url = url.replace(targetPattern, '');
              }
              return url;
          }
          /*
           * Extract scheme/protocol from URL
           */
          function getProtocolScheme(url) {
              var e = new RegExp('^([a-z]+):'), matches = e.exec(url);
              return matches ? matches[1] : null;
          }
          /*
           * Resolve relative reference
           *
           * Note: not as described in rfc3986 section 5.2
           */
          function resolveRelativeReference(baseUrl, url) {
              var protocol = getProtocolScheme(url), i;
              if (protocol) {
                  return url;
              }
              if (url.slice(0, 1) === '/') {
                  return getProtocolScheme(baseUrl) + '://' + getHostName(baseUrl) + url;
              }
              baseUrl = purify(baseUrl);
              if ((i = baseUrl.indexOf('?')) >= 0) {
                  baseUrl = baseUrl.slice(0, i);
              }
              if ((i = baseUrl.lastIndexOf('/')) !== baseUrl.length - 1) {
                  baseUrl = baseUrl.slice(0, i + 1);
              }
              return baseUrl + url;
          }
          /*
           * Send request
           */
          function sendRequest(request) {
              if (!(configDoNotTrack || toOptoutByCookie)) {
                  outQueue.enqueueRequest(request.build());
              }
          }
          /*
           * Get cookie name with prefix and domain hash
           */
          function getSnowplowCookieName(baseName) {
              return configCookieNamePrefix + baseName + '.' + domainHash;
          }
          /*
           * Cookie getter.
           */
          function getSnowplowCookieValue(cookieName) {
              var fullName = getSnowplowCookieName(cookieName);
              if (configStateStorageStrategy == 'localStorage') {
                  return attemptGetLocalStorage(fullName);
              }
              else if (configStateStorageStrategy == 'cookie' || configStateStorageStrategy == 'cookieAndLocalStorage') {
                  return cookieStorage.getCookie(fullName);
              }
              return undefined;
          }
          /*
           * Update domain hash
           */
          function updateDomainHash() {
              refreshUrl();
              domainHash = hash((configCookieDomain || domainAlias) + (configCookiePath || '/')).slice(0, 4); // 4 hexits = 16 bits
          }
          /*
           * Process all "activity" events.
           * For performance, this function must have low overhead.
           */
          function activityHandler() {
              var now = new Date();
              lastActivityTime = now.getTime();
          }
          /*
           * Process all "scroll" events.
           */
          function scrollHandler() {
              updateMaxScrolls();
              activityHandler();
          }
          /*
           * Returns [pageXOffset, pageYOffset]
           */
          function getPageOffsets() {
              var documentElement = document.documentElement;
              if (documentElement) {
                  return [documentElement.scrollLeft || window.pageXOffset, documentElement.scrollTop || window.pageYOffset];
              }
              return [0, 0];
          }
          /*
           * Quick initialization/reset of max scroll levels
           */
          function resetMaxScrolls() {
              var offsets = getPageOffsets();
              var x = offsets[0];
              minXOffset = x;
              maxXOffset = x;
              var y = offsets[1];
              minYOffset = y;
              maxYOffset = y;
          }
          /*
           * Check the max scroll levels, updating as necessary
           */
          function updateMaxScrolls() {
              var offsets = getPageOffsets();
              var x = offsets[0];
              if (x < minXOffset) {
                  minXOffset = x;
              }
              else if (x > maxXOffset) {
                  maxXOffset = x;
              }
              var y = offsets[1];
              if (y < minYOffset) {
                  minYOffset = y;
              }
              else if (y > maxYOffset) {
                  maxYOffset = y;
              }
          }
          /*
           * Prevents offsets from being decimal or NaN
           * See https://github.com/snowplow/snowplow-javascript-tracker/issues/324
           */
          function cleanOffset(offset) {
              return Math.round(offset);
          }
          /**
           * Sets or renews the session cookie.
           * Responsible for calling the `onSessionUpdateCallback` callback.
           * @returns {boolean} If the value persisted in cookies or LocalStorage
           */
          function setSessionCookie() {
              var cookieName = getSnowplowCookieName('ses');
              var cookieValue = '*';
              return persistValue(cookieName, cookieValue, configSessionCookieTimeout);
          }
          /**
           * @mutates idCookie
           * @param {ParsedIdCookie} idCookie
           * @returns {boolean} If the value persisted in cookies or LocalStorage
           */
          function setDomainUserIdCookie(idCookie) {
              var cookieName = getSnowplowCookieName('id');
              var cookieValue = serializeIdCookie(idCookie, configAnonymousTracking);
              return persistValue(cookieName, cookieValue, configVisitorCookieTimeout);
          }
          /**
           * no-op if anonymousTracking enabled, will still set cookies if anonymousSessionTracking is enabled
           * Sets a cookie based on the storage strategy:
           * - if 'localStorage': attempts to write to local storage
           * - if 'cookie' or 'cookieAndLocalStorage': writes to cookies
           * - otherwise: no-op
           * @param {string} name Name/key of the value to persist
           * @param {string} value
           * @param {number} timeout Used as the expiration date for cookies or as a TTL to be checked on LocalStorage
           * @returns {boolean} If the operation was successful or not
           */
          function persistValue(name, value, timeout) {
              if (configAnonymousTracking && !configAnonymousSessionTracking) {
                  return false;
              }
              if (configStateStorageStrategy == 'localStorage') {
                  return attemptWriteLocalStorage(name, value, timeout);
              }
              else if (configStateStorageStrategy == 'cookie' || configStateStorageStrategy == 'cookieAndLocalStorage') {
                  return cookieStorage.setCookie(name, value, timeout, configCookiePath, configCookieDomain, configCookieSameSite, configCookieSecure);
              }
              return false;
          }
          /**
           * Clears all cookie and local storage for id and ses values
           */
          function clearUserDataAndCookies(configuration) {
              var idname = getSnowplowCookieName('id');
              var sesname = getSnowplowCookieName('ses');
              attemptDeleteLocalStorage(idname);
              attemptDeleteLocalStorage(sesname);
              cookieStorage.deleteCookie(idname, configCookiePath, configCookieDomain, configCookieSameSite, configCookieSecure);
              cookieStorage.deleteCookie(sesname, configCookiePath, configCookieDomain, configCookieSameSite, configCookieSecure);
              if (!(configuration === null || configuration === void 0 ? void 0 : configuration.preserveSession)) {
                  memorizedSessionId = v4();
                  memorizedVisitCount = 1;
              }
              if (!(configuration === null || configuration === void 0 ? void 0 : configuration.preserveUser)) {
                  domainUserId = configAnonymousTracking ? '' : v4();
                  businessUserId = null;
              }
          }
          /**
           * Toggle Anonymous Tracking
           */
          function toggleAnonymousTracking(configuration) {
              if (configuration && configuration.stateStorageStrategy) {
                  trackerConfiguration.stateStorageStrategy = configuration.stateStorageStrategy;
                  configStateStorageStrategy = getStateStorageStrategy(trackerConfiguration);
              }
              configAnonymousTracking = getAnonymousTracking(trackerConfiguration);
              configAnonymousSessionTracking = getAnonymousSessionTracking(trackerConfiguration);
              configAnonymousServerTracking = getAnonymousServerTracking(trackerConfiguration);
              outQueue.setUseLocalStorage(configStateStorageStrategy == 'localStorage' || configStateStorageStrategy == 'cookieAndLocalStorage');
              outQueue.setAnonymousTracking(configAnonymousServerTracking);
          }
          /*
           * Load the domain user ID and the session ID
           * Set the cookies (if cookies are enabled)
           */
          function initializeIdsAndCookies() {
              if (configAnonymousTracking && !configAnonymousSessionTracking) {
                  return;
              }
              var sesCookieSet = configStateStorageStrategy != 'none' && !!getSnowplowCookieValue('ses');
              var idCookie = loadDomainUserIdCookie();
              domainUserId = initializeDomainUserId(idCookie, configAnonymousTracking);
              if (!sesCookieSet) {
                  memorizedSessionId = startNewIdCookieSession(idCookie);
              }
              else {
                  memorizedSessionId = sessionIdFromIdCookie(idCookie);
              }
              memorizedVisitCount = visitCountFromIdCookie(idCookie);
              if (configStateStorageStrategy != 'none') {
                  setSessionCookie();
                  // Update currentVisitTs
                  updateNowTsInIdCookie(idCookie);
                  setDomainUserIdCookie(idCookie);
                  if (!eventIndexFromIdCookie(idCookie)) {
                      // Synchronously update the cookies to persist the new session ASAP
                      cookieStorage.flush();
                  }
              }
          }
          /*
           * Load visitor ID cookie
           */
          function loadDomainUserIdCookie() {
              if (configStateStorageStrategy == 'none') {
                  return emptyIdCookie();
              }
              var id = getSnowplowCookieValue('id') || undefined;
              return parseIdCookie(id, domainUserId, memorizedSessionId, memorizedVisitCount);
          }
          /**
           * Adds the protocol in front of our collector URL
           *
           * @param string - collectorUrl The collector URL with or without protocol
           * @returns string collectorUrl The tracker URL with protocol
           */
          function asCollectorUrl(collectorUrl) {
              if (collectorUrl.indexOf('http') === 0) {
                  return collectorUrl;
              }
              return ('https:' === document.location.protocol ? 'https' : 'http') + '://' + collectorUrl;
          }
          /**
           * Initialize new `pageViewId` if it shouldn't be preserved.
           * Should be called when `trackPageView` is invoked
           */
          function resetPageView() {
              if (!preservePageViewId || state.pageViewId == null) {
                  state.pageViewId = v4();
                  state.pageViewUrl = configCustomUrl || locationHrefAlias;
              }
          }
          /**
           * Safe function to get `pageViewId`.
           * Generates it if it wasn't initialized by other tracker
           */
          function getPageViewId() {
              if (shouldGenerateNewPageViewId()) {
                  state.pageViewId = v4();
                  state.pageViewUrl = configCustomUrl || locationHrefAlias;
              }
              return state.pageViewId;
          }
          function shouldGenerateNewPageViewId() {
              // If pageViewId is not initialized, generate it
              if (state.pageViewId == null) {
                  return true;
              }
              // If pageViewId should be preserved regardless of the URL, don't generate a new one
              if (preservePageViewId || !preservePageViewIdForUrl) {
                  return false;
              }
              // If doesn't have previous URL in state, generate a new pageViewId
              if (state.pageViewUrl === undefined) {
                  return true;
              }
              var current = configCustomUrl || locationHrefAlias;
              // If full preserve is enabled, compare the full URL
              if (preservePageViewIdForUrl === true || preservePageViewIdForUrl == 'full' || !('URL' in window)) {
                  return state.pageViewUrl != current;
              }
              var currentUrl = new URL(current);
              var previousUrl = new URL(state.pageViewUrl);
              // If pathname preserve is enabled, compare the pathname
              if (preservePageViewIdForUrl == 'pathname') {
                  return currentUrl.pathname != previousUrl.pathname;
              }
              // If pathname and search preserve is enabled, compare the pathname and search
              if (preservePageViewIdForUrl == 'pathnameAndSearch') {
                  return currentUrl.pathname != previousUrl.pathname || currentUrl.search != previousUrl.search;
              }
              return false;
          }
          /**
           * Safe function to get `tabId`.
           * Generates it if it is not yet initialized. Shared between trackers.
           */
          function getTabId() {
              if (configStateStorageStrategy === 'none' || configAnonymousTracking || !isWebPageContextAvailable) {
                  return null;
              }
              var SESSION_STORAGE_TAB_ID = '_sp_tab_id';
              var tabId = attemptGetSessionStorage(SESSION_STORAGE_TAB_ID);
              if (!tabId) {
                  attemptWriteSessionStorage(SESSION_STORAGE_TAB_ID, v4());
                  tabId = attemptGetSessionStorage(SESSION_STORAGE_TAB_ID);
              }
              return tabId || null;
          }
          /**
           * Put together a web page context with a unique UUID for the page view
           *
           * @returns web_page context
           */
          function getWebPagePlugin() {
              return {
                  contexts: function () {
                      return [
                          {
                              schema: WEB_PAGE_SCHEMA,
                              data: {
                                  id: getPageViewId(),
                              },
                          },
                      ];
                  },
              };
          }
          function getBrowserContextPlugin() {
              return {
                  contexts: function () {
                      return [
                          {
                              schema: BROWSER_CONTEXT_SCHEMA,
                              data: __assign(__assign({}, getBrowserProperties()), { tabId: getTabId() }),
                          },
                      ];
                  },
              };
          }
          /*
           * Attaches common web fields to every request (resolution, url, referrer, etc.)
           * Also sets the required cookies.
           */
          function getBrowserDataPlugin() {
              var anonymizeOr = function (value) { return (configAnonymousTracking ? null : value); };
              var anonymizeSessionOr = function (value) {
                  return configAnonymousSessionTracking ? value : anonymizeOr(value);
              };
              return {
                  beforeTrack: function (payloadBuilder) {
                      var existingSession = getSnowplowCookieValue('ses'), idCookie = loadDomainUserIdCookie();
                      var isFirstEventInSession = eventIndexFromIdCookie(idCookie) === 0;
                      if (configOptOutCookie) {
                          toOptoutByCookie = !!cookieStorage.getCookie(configOptOutCookie);
                      }
                      else {
                          toOptoutByCookie = false;
                      }
                      if (configDoNotTrack || toOptoutByCookie) {
                          clearUserDataAndCookies();
                          return;
                      }
                      // If cookies are enabled, base visit count and session ID on the cookies
                      if (cookiesEnabledInIdCookie(idCookie)) {
                          // New session?
                          if (!existingSession && configStateStorageStrategy != 'none') {
                              memorizedSessionId = startNewIdCookieSession(idCookie);
                          }
                          else {
                              memorizedSessionId = sessionIdFromIdCookie(idCookie);
                          }
                          memorizedVisitCount = visitCountFromIdCookie(idCookie);
                      }
                      else if (new Date().getTime() - lastEventTime > configSessionCookieTimeout * 1000) {
                          memorizedVisitCount++;
                          memorizedSessionId = startNewIdCookieSession(idCookie, {
                              memorizedVisitCount: memorizedVisitCount,
                          });
                      }
                      // Update cookie
                      updateNowTsInIdCookie(idCookie);
                      updateFirstEventInIdCookie(idCookie, payloadBuilder);
                      incrementEventIndexInIdCookie(idCookie);
                      var _a = getBrowserProperties(), viewport = _a.viewport, documentSize = _a.documentSize;
                      payloadBuilder.add('vp', viewport);
                      payloadBuilder.add('ds', documentSize);
                      payloadBuilder.add('vid', anonymizeSessionOr(memorizedVisitCount));
                      payloadBuilder.add('sid', anonymizeSessionOr(memorizedSessionId));
                      payloadBuilder.add('duid', anonymizeOr(domainUserIdFromIdCookie(idCookie))); // Always load from cookie as this is better etiquette than in-memory values
                      payloadBuilder.add('uid', anonymizeOr(businessUserId));
                      refreshUrl();
                      payloadBuilder.add('refr', purify(customReferrer || configReferrerUrl));
                      // Add the page URL last as it may take us over the IE limit (and we don't always need it)
                      payloadBuilder.add('url', purify(configCustomUrl || locationHrefAlias));
                      var clientSession = clientSessionFromIdCookie(idCookie, configStateStorageStrategy, configAnonymousTracking);
                      if (configSessionContext && (!configAnonymousTracking || configAnonymousSessionTracking)) {
                          addSessionContextToPayload(payloadBuilder, clientSession);
                      }
                      // Update cookies
                      if (configStateStorageStrategy != 'none') {
                          setDomainUserIdCookie(idCookie);
                          var sessionIdentifierPersisted = setSessionCookie();
                          if ((!existingSession || isFirstEventInSession) &&
                              sessionIdentifierPersisted &&
                              onSessionUpdateCallback &&
                              !manualSessionUpdateCalled) {
                              // Synchronously update the cookies to persist the new session ASAP
                              cookieStorage.flush();
                              onSessionUpdateCallback(clientSession);
                              manualSessionUpdateCalled = false;
                          }
                      }
                      lastEventTime = new Date().getTime();
                  },
              };
          }
          function addSessionContextToPayload(payloadBuilder, clientSession) {
              var sessionContext = {
                  schema: CLIENT_SESSION_SCHEMA,
                  data: clientSession,
              };
              payloadBuilder.addContextEntity(sessionContext);
          }
          /**
           * Expires current session and starts a new session.
           */
          function newSession() {
              // If cookies are enabled, base visit count and session ID on the cookies
              var idCookie = loadDomainUserIdCookie();
              // When cookies are enabled
              if (cookiesEnabledInIdCookie(idCookie)) {
                  // When cookie/local storage is enabled - make a new session
                  if (configStateStorageStrategy != 'none') {
                      memorizedSessionId = startNewIdCookieSession(idCookie);
                  }
                  else {
                      memorizedSessionId = sessionIdFromIdCookie(idCookie);
                  }
                  memorizedVisitCount = visitCountFromIdCookie(idCookie);
              }
              else {
                  memorizedVisitCount++;
                  memorizedSessionId = startNewIdCookieSession(idCookie, {
                      memorizedVisitCount: memorizedVisitCount,
                  });
              }
              updateNowTsInIdCookie(idCookie);
              // Update cookies
              if (configStateStorageStrategy != 'none') {
                  var clientSession = clientSessionFromIdCookie(idCookie, configStateStorageStrategy, configAnonymousTracking);
                  setDomainUserIdCookie(idCookie);
                  var sessionIdentifierPersisted = setSessionCookie();
                  // Synchronously update the cookies to persist the new session ASAP
                  cookieStorage.flush();
                  if (sessionIdentifierPersisted && onSessionUpdateCallback) {
                      manualSessionUpdateCalled = true;
                      onSessionUpdateCallback(clientSession);
                  }
              }
              lastEventTime = new Date().getTime();
          }
          /**
           * Combine an array of unchanging contexts with the result of a context-creating function
           *
           * @param staticContexts - Array of custom contexts
           * @param contextCallback - Function returning an array of contexts
           */
          function finalizeContexts(staticContexts, contextCallback) {
              return (staticContexts || []).concat(contextCallback ? contextCallback() : []);
          }
          function logPageView(_a) {
              var title = _a.title, context = _a.context, timestamp = _a.timestamp, contextCallback = _a.contextCallback;
              refreshUrl();
              if (lastSentPageViewId && lastSentPageViewId == getPageViewId()) {
                  // Do not reset pageViewId if a page view was not tracked yet or a different page view ID was used (in order to support multiple trackers with shared state)
                  resetPageView();
              }
              lastSentPageViewId = getPageViewId();
              // So we know what document.title was at the time of trackPageView
              lastDocumentTitle = document.title;
              if (title) {
                  lastConfigTitle = title;
                  lastConfigTitleFromTrackPageView = true;
              }
              else if (lastConfigTitleFromTrackPageView) {
                  lastConfigTitle = null;
              }
              // Fixup page title
              var pageTitle = fixupTitle(lastConfigTitle || lastDocumentTitle);
              // Log page view
              core.track(buildPageView({
                  pageUrl: purify(configCustomUrl || locationHrefAlias),
                  pageTitle: pageTitle,
                  referrer: purify(customReferrer || configReferrerUrl),
              }), finalizeContexts(context, contextCallback), timestamp);
              // Send ping (to log that user has stayed on page)
              var now = new Date();
              var installingActivityTracking = false;
              if (activityTrackingConfig.enabled && !activityTrackingConfig.installed) {
                  activityTrackingConfig.installed = true;
                  installingActivityTracking = true;
                  // Add mousewheel event handler, detect passive event listeners for performance
                  var detectPassiveEvents_1 = {
                      update: function update() {
                          if (typeof window !== 'undefined' && typeof window.addEventListener === 'function') {
                              var passive_1 = false;
                              var options = Object.defineProperty({}, 'passive', {
                                  get: function get() {
                                      passive_1 = true;
                                  },
                                  set: function set() { },
                              });
                              // note: have to set and remove a no-op listener instead of null
                              // (which was used previously), because Edge v15 throws an error
                              // when providing a null callback.
                              // https://github.com/rafrex/detect-passive-events/pull/3
                              var noop = function noop() { };
                              window.addEventListener('testPassiveEventSupport', noop, options);
                              window.removeEventListener('testPassiveEventSupport', noop, options);
                              detectPassiveEvents_1.hasSupport = passive_1;
                          }
                      },
                  };
                  detectPassiveEvents_1.update();
                  // Detect available wheel event
                  var wheelEvent = 'onwheel' in document.createElement('div')
                      ? 'wheel' // Modern browsers support "wheel"
                      : document.onmousewheel !== undefined
                          ? 'mousewheel' // Webkit and IE support at least "mousewheel"
                          : 'DOMMouseScroll'; // let's assume that remaining browsers are older Firefox
                  if (Object.prototype.hasOwnProperty.call(detectPassiveEvents_1, 'hasSupport')) {
                      addEventListener(document, wheelEvent, activityHandler, { passive: true });
                  }
                  else {
                      addEventListener(document, wheelEvent, activityHandler);
                  }
                  // Capture our initial scroll points
                  resetMaxScrolls();
                  // Add event handlers; cross-browser compatibility here varies significantly
                  // @see http://quirksmode.org/dom/events
                  var documentHandlers = [
                      'click',
                      'mouseup',
                      'mousedown',
                      'mousemove',
                      'keypress',
                      'keydown',
                      'keyup',
                      'touchend',
                      'touchstart',
                  ];
                  var windowHandlers = ['resize', 'focus', 'blur'];
                  var listener = function (_, handler) {
                      if (handler === void 0) { handler = activityHandler; }
                      return function (ev) {
                          return addEventListener(document, ev, handler);
                      };
                  };
                  documentHandlers.forEach(listener(document));
                  windowHandlers.forEach(listener(window));
                  listener(window, scrollHandler)('scroll');
              }
              if (activityTrackingConfig.enabled && (resetActivityTrackingOnPageView || installingActivityTracking)) {
                  // Periodic check for activity.
                  lastActivityTime = now.getTime();
                  var key = void 0;
                  for (key in activityTrackingConfig.configurations) {
                      var config = activityTrackingConfig.configurations[key];
                      if (config) {
                          //Clear page ping heartbeat on new page view
                          window.clearInterval(config.activityInterval);
                          scheduleActivityInterval(config, context, contextCallback);
                      }
                  }
              }
          }
          function scheduleActivityInterval(config, context, contextCallback) {
              var executePagePing = function (cb, context) {
                  refreshUrl();
                  cb({ context: context, pageViewId: getPageViewId(), minXOffset: minXOffset, minYOffset: minYOffset, maxXOffset: maxXOffset, maxYOffset: maxYOffset });
                  resetMaxScrolls();
              };
              var timeout = function () {
                  var now = new Date();
                  // There was activity during the heart beat period;
                  // on average, this is going to overstate the visitDuration by configHeartBeatTimer/2
                  if (lastActivityTime + config.configMinimumVisitLength > now.getTime()) {
                      executePagePing(config.callback, finalizeContexts(context, contextCallback));
                  }
                  config.activityInterval = window.setInterval(heartbeat, config.configHeartBeatTimer);
              };
              var heartbeat = function () {
                  var now = new Date();
                  // There was activity during the heart beat period;
                  // on average, this is going to overstate the visitDuration by configHeartBeatTimer/2
                  if (lastActivityTime + config.configHeartBeatTimer > now.getTime()) {
                      executePagePing(config.callback, finalizeContexts(context, contextCallback));
                  }
              };
              if (config.configMinimumVisitLength === 0) {
                  config.activityInterval = window.setInterval(heartbeat, config.configHeartBeatTimer);
              }
              else {
                  config.activityInterval = window.setTimeout(timeout, config.configMinimumVisitLength);
              }
          }
          /**
           * Configure the activity tracking and ensures integer values for min visit and heartbeat
           */
          function configureActivityTracking(configuration) {
              var minimumVisitLength = configuration.minimumVisitLength, heartbeatDelay = configuration.heartbeatDelay, callback = configuration.callback;
              if (isInteger(minimumVisitLength) && isInteger(heartbeatDelay)) {
                  return {
                      configMinimumVisitLength: minimumVisitLength * 1000,
                      configHeartBeatTimer: heartbeatDelay * 1000,
                      callback: callback,
                  };
              }
              LOG.error('Activity tracking minimumVisitLength & heartbeatDelay must be integers');
              return undefined;
          }
          /**
           * Log that a user is still viewing a given page by sending a page ping.
           * Not part of the public API - only called from logPageView() above.
           */
          function logPagePing(_a) {
              var context = _a.context, minXOffset = _a.minXOffset, minYOffset = _a.minYOffset, maxXOffset = _a.maxXOffset, maxYOffset = _a.maxYOffset;
              var newDocumentTitle = document.title;
              if (newDocumentTitle !== lastDocumentTitle) {
                  lastDocumentTitle = newDocumentTitle;
                  lastConfigTitle = undefined;
              }
              core.track(buildPagePing({
                  pageUrl: purify(configCustomUrl || locationHrefAlias),
                  pageTitle: fixupTitle(lastConfigTitle || lastDocumentTitle),
                  referrer: purify(customReferrer || configReferrerUrl),
                  minXOffset: cleanOffset(minXOffset),
                  maxXOffset: cleanOffset(maxXOffset),
                  minYOffset: cleanOffset(minYOffset),
                  maxYOffset: cleanOffset(maxYOffset),
              }), context);
          }
          function disableActivityTrackingAction(actionKey) {
              var callbackConfiguration = activityTrackingConfig.configurations[actionKey];
              if ((callbackConfiguration === null || callbackConfiguration === void 0 ? void 0 : callbackConfiguration.configMinimumVisitLength) === 0) {
                  window.clearTimeout(callbackConfiguration === null || callbackConfiguration === void 0 ? void 0 : callbackConfiguration.activityInterval);
              }
              else {
                  window.clearInterval(callbackConfiguration === null || callbackConfiguration === void 0 ? void 0 : callbackConfiguration.activityInterval);
              }
              activityTrackingConfig.configurations[actionKey] = undefined;
          }
          var apiMethods = {
              getDomainSessionIndex: function () {
                  return memorizedVisitCount;
              },
              getPageViewId: getPageViewId,
              getTabId: getTabId,
              newSession: newSession,
              getCookieName: function (basename) {
                  return getSnowplowCookieName(basename);
              },
              getUserId: function () {
                  return businessUserId;
              },
              getDomainUserId: function () {
                  return loadDomainUserIdCookie()[1];
              },
              getDomainUserInfo: function () {
                  return loadDomainUserIdCookie();
              },
              setReferrerUrl: function (url) {
                  customReferrer = url;
              },
              setCustomUrl: function (url) {
                  refreshUrl();
                  configCustomUrl = resolveRelativeReference(locationHrefAlias, url);
              },
              setDocumentTitle: function (title) {
                  // So we know what document.title was at the time of trackPageView
                  lastDocumentTitle = document.title;
                  lastConfigTitle = title;
                  lastConfigTitleFromTrackPageView = false;
              },
              discardHashTag: function (enableFilter) {
                  configDiscardHashTag = enableFilter;
              },
              discardBrace: function (enableFilter) {
                  configDiscardBrace = enableFilter;
              },
              setCookiePath: function (path) {
                  configCookiePath = path;
                  updateDomainHash();
              },
              setVisitorCookieTimeout: function (timeout) {
                  configVisitorCookieTimeout = timeout;
              },
              crossDomainLinker: function (crossDomainLinkerCriterion) {
                  decorateLinks(crossDomainLinkerCriterion);
              },
              enableActivityTracking: function (configuration) {
                  if (!activityTrackingConfig.configurations.pagePing) {
                      activityTrackingConfig.enabled = true;
                      activityTrackingConfig.configurations.pagePing = configureActivityTracking(__assign(__assign({}, configuration), { callback: logPagePing }));
                  }
              },
              enableActivityTrackingCallback: function (configuration) {
                  if (!activityTrackingConfig.configurations.callback) {
                      activityTrackingConfig.enabled = true;
                      activityTrackingConfig.configurations.callback = configureActivityTracking(configuration);
                  }
              },
              disableActivityTracking: function () {
                  disableActivityTrackingAction('pagePing');
              },
              disableActivityTrackingCallback: function () {
                  disableActivityTrackingAction('callback');
              },
              updatePageActivity: function () {
                  activityHandler();
              },
              setOptOutCookie: function (name) {
                  configOptOutCookie = name;
              },
              setUserId: function (userId) {
                  businessUserId = userId;
              },
              setUserIdFromLocation: function (querystringField) {
                  refreshUrl();
                  businessUserId = fromQuerystring(querystringField, locationHrefAlias);
              },
              setUserIdFromReferrer: function (querystringField) {
                  refreshUrl();
                  businessUserId = fromQuerystring(querystringField, configReferrerUrl);
              },
              setUserIdFromCookie: function (cookieName) {
                  businessUserId = cookieStorage.getCookie(cookieName);
              },
              setCollectorUrl: function (collectorUrl) {
                  outQueue.setCollectorUrl(asCollectorUrl(collectorUrl));
              },
              setBufferSize: function (newBufferSize) {
                  outQueue.setBufferSize(newBufferSize);
              },
              flushBuffer: function (configuration) {
                  if (configuration === void 0) { configuration = {}; }
                  outQueue.executeQueue();
                  if (configuration.newBufferSize) {
                      outQueue.setBufferSize(configuration.newBufferSize);
                  }
              },
              trackPageView: function (event) {
                  if (event === void 0) { event = {}; }
                  logPageView(event);
              },
              preservePageViewId: function () {
                  preservePageViewId = true;
              },
              preservePageViewIdForUrl: function (preserve) {
                  preservePageViewIdForUrl = preserve;
              },
              disableAnonymousTracking: function (configuration) {
                  trackerConfiguration.anonymousTracking = false;
                  toggleAnonymousTracking(configuration);
                  initializeIdsAndCookies();
                  outQueue.executeQueue(); // There might be some events in the queue we've been unable to send in anonymous mode
              },
              enableAnonymousTracking: function (configuration) {
                  var _a;
                  trackerConfiguration.anonymousTracking = (_a = (configuration && (configuration === null || configuration === void 0 ? void 0 : configuration.options))) !== null && _a !== void 0 ? _a : true;
                  toggleAnonymousTracking(configuration);
                  // Reset the page view, if not tracking the session, so can't stitch user into new events on the page view id
                  if (!configAnonymousSessionTracking) {
                      resetPageView();
                  }
              },
              clearUserData: clearUserDataAndCookies,
          };
          return __assign(__assign({}, apiMethods), { id: trackerId, namespace: namespace, core: core, sharedState: state });
      };
      // Initialise the tracker
      var partialTracker = newTracker(trackerId, namespace, version, endpoint, sharedState, trackerConfiguration), tracker = __assign(__assign({}, partialTracker), { addPlugin: function (configuration) {
              var _a, _b;
              tracker.core.addPlugin(configuration);
              (_b = (_a = configuration.plugin).activateBrowserPlugin) === null || _b === void 0 ? void 0 : _b.call(_a, tracker);
          } });
      // Initialise each plugin with the tracker
      browserPlugins.forEach(function (p) {
          var _a;
          (_a = p.activateBrowserPlugin) === null || _a === void 0 ? void 0 : _a.call(p, tracker);
      });
      return tracker;
  }

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  var namedTrackers = {};
  /**
   * Dispatch function to all specified trackers
   *
   * @param trackers - An optional list of trackers to send the event to, or will send to all trackers
   * @param fn - The function which will run against each tracker
   */
  function dispatchToTrackers(trackers, fn) {
      try {
          getTrackers(trackers !== null && trackers !== void 0 ? trackers : allTrackerNames()).forEach(fn);
      }
      catch (ex) {
          LOG.error('Function failed', ex);
      }
  }
  /**
   * Creates a Tracker and adds it to the internal collection
   * @param trackerId - The unique identifier of the tracker
   * @param namespace - The namespace of the tracker, tracked with each event as `tna`
   * @param version - The current version of the tracker library
   * @param endpoint - The endpoint to send events to
   * @param sharedState - The instance of shared state to use for this tracker
   * @param configuration - The configuration to use for this tracker instance
   */
  function addTracker(trackerId, namespace, version, endpoint, sharedState, configuration) {
      if (!namedTrackers.hasOwnProperty(trackerId)) {
          namedTrackers[trackerId] = Tracker(trackerId, namespace, version, endpoint, sharedState, configuration);
          return namedTrackers[trackerId];
      }
      return null;
  }
  /**
   * Gets an array of tracker instances based on the list of identifiers
   * @param trackerIds - An array of unique identifiers of the trackers
   * @returns The tracker instances, or empty list if none found
   */
  function getTrackers(trackerIds) {
      return getTrackersFromCollection(trackerIds, namedTrackers);
  }
  /**
   * Returns all the unique tracker identifiers
   */
  function allTrackerNames() {
      return Object.keys(namedTrackers);
  }
  function getTrackersFromCollection(trackerIds, trackerCollection) {
      var trackers = [];
      for (var _i = 0, trackerIds_1 = trackerIds; _i < trackerIds_1.length; _i++) {
          var id = trackerIds_1[_i];
          if (trackerCollection.hasOwnProperty(id)) {
              trackers.push(trackerCollection[id]);
          }
          else {
              LOG.warn(id + ' not configured');
          }
      }
      return trackers;
  }

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  /**
   * A set of variables which are shared among all initialised trackers
   */
  var SharedState = /** @class */ (function () {
      function SharedState() {
          this.bufferFlushers = [];
          /* DOM Ready */
          this.hasLoaded = false;
          this.registeredOnLoadHandlers = [];
      }
      return SharedState;
  }());
  function createSharedState() {
      var sharedState = new SharedState(), documentAlias = document, windowAlias = window;
      /*
       * Handle page visibility event
       * Works everywhere except IE9
       */
      function visibilityChangeHandler() {
          if (documentAlias.visibilityState == 'hidden') {
              // Flush all POST queues
              sharedState.bufferFlushers.forEach(function (flusher) {
                  flusher(false);
              });
          }
      }
      function flushBuffers() {
          // Flush all POST queues
          sharedState.bufferFlushers.forEach(function (flusher) {
              flusher(false);
          });
      }
      /*
       * Handler for onload event
       */
      function loadHandler() {
          var i;
          if (!sharedState.hasLoaded) {
              sharedState.hasLoaded = true;
              for (i = 0; i < sharedState.registeredOnLoadHandlers.length; i++) {
                  sharedState.registeredOnLoadHandlers[i]();
              }
          }
          return true;
      }
      /*
       * Add onload or DOM ready handler
       */
      function addReadyListener() {
          if (documentAlias.addEventListener) {
              documentAlias.addEventListener('DOMContentLoaded', function ready() {
                  documentAlias.removeEventListener('DOMContentLoaded', ready, false);
                  loadHandler();
              });
          }
          else if (documentAlias.attachEvent) {
              documentAlias.attachEvent('onreadystatechange', function ready() {
                  if (documentAlias.readyState === 'complete') {
                      documentAlias.detachEvent('onreadystatechange', ready);
                      loadHandler();
                  }
              });
          }
          // fallback
          addEventListener(windowAlias, 'load', loadHandler, false);
      }
      /************************************************************
       * Constructor
       ************************************************************/
      // initialize the Snowplow singleton
      if (documentAlias.visibilityState) {
          // Flush for mobile and modern browsers
          addEventListener(documentAlias, 'visibilitychange', visibilityChangeHandler, false);
      }
      // Last attempt at flushing in beforeunload
      addEventListener(windowAlias, 'beforeunload', flushBuffers, false);
      if (document.readyState === 'loading') {
          addReadyListener();
      }
      else {
          loadHandler();
      }
      return sharedState;
  }

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  /**
   * Expires current session and starts a new session.
   *
   * @param trackers - The tracker identifiers which will have their session refreshed
   */
  function newSession(trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.newSession();
      });
  }
  /**
   * Override referrer
   *
   * @param url - Custom Referrer which will be used as override
   * @param trackers - The tracker identifiers which will be configured
   */
  function setReferrerUrl(url, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.setReferrerUrl(url);
      });
  }
  /**
   * Override url
   *
   * @param url - Custom URL which will be used as override
   * @param trackers - The tracker identifiers which will be configured
   */
  function setCustomUrl(url, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.setCustomUrl(url);
      });
  }
  /**
   * Override document.title
   *
   * @param title - Document title which will be used as override
   * @param trackers - The tracker identifiers which will be configured
   */
  function setDocumentTitle(title, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.setDocumentTitle(title);
      });
  }
  /**
   * Strip hash tag (or anchor) from URL
   *
   * @param enable - Whether to enable stripping of hash
   * @param trackers - The tracker identifiers which will be configured
   */
  function discardHashTag(enable, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.discardHashTag(enable);
      });
  }
  /**
   * Strip braces from URL
   *
   * @param enable - Whther to enable stripping of braces
   * @param trackers - The tracker identifiers which will be configured
   */
  function discardBrace(enable, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.discardBrace(enable);
      });
  }
  /**
   * Set first-party cookie path
   *
   * @param path - The path which will be used when setting cookies
   * @param trackers - The tracker identifiers which will be configured
   */
  function setCookiePath(path, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.setCookiePath(path);
      });
  }
  /**
   * Set visitor cookie timeout (in seconds)
   *
   * @param timeout - The timeout until cookies will expire
   * @param trackers - The tracker identifiers which will be configured
   */
  function setVisitorCookieTimeout(timeout, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.setVisitorCookieTimeout(timeout);
      });
  }
  /**
   * Enable querystring decoration for links passing a filter
   *
   * @param crossDomainLinker - Function used to determine which links to decorate
   * @param trackers - The tracker identifiers which will be configured
   */
  function crossDomainLinker(crossDomainLinkerCriterion, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.crossDomainLinker(crossDomainLinkerCriterion);
      });
  }
  /**
   * Enables page activity tracking (sends page pings to the Collector regularly).
   *
   * @param configuration - The activity tracking configuration
   * @param trackers - The tracker identifiers which will be configured
   */
  function enableActivityTracking(configuration, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.enableActivityTracking(configuration);
      });
  }
  /**
   * Enables page activity tracking (replaces collector ping with callback).
   *
   * @param configuration - The activity tracking callback configuration
   * @param trackers - The tracker identifiers which will be configured
   */
  function enableActivityTrackingCallback(configuration, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.enableActivityTrackingCallback(configuration);
      });
  }
  /**
   * Disables page activity tracking.
   *
   * @param trackers - The tracker identifiers the activity tracking will be disabled.
   */
  function disableActivityTracking(trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.disableActivityTracking();
      });
  }
  /**
   * Disables page activity tracking callback.
   *
   * @param trackers - The tracker identifiers the activity tracking callback will be disabled.
   */
  function disableActivityTrackingCallback(trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.disableActivityTrackingCallback();
      });
  }
  /**
   * Triggers the activityHandler manually to allow external user defined activity. i.e. While watching a video
   *
   * @param trackers - The tracker identifiers which will be updated
   */
  function updatePageActivity(trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.updatePageActivity();
      });
  }
  /**
   * Sets the opt out cookie.
   *
   * @param name - of the opt out cookie
   * @param trackers - The tracker identifiers which will be configured
   */
  function setOptOutCookie(name, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.setOptOutCookie(name);
      });
  }
  /**
   * Set the business-defined user ID for this user.
   *
   * @param userId - The business-defined user ID
   * @param trackers - The tracker identifiers which will be configured
   */
  function setUserId(userId, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.setUserId(userId);
      });
  }
  /**
   * Set the business-defined user ID for this user using the location querystring.
   *
   * @param querystringField - Name of a querystring name-value pair
   * @param trackers - The tracker identifiers which will be configured
   */
  function setUserIdFromLocation(querystringField, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.setUserIdFromLocation(querystringField);
      });
  }
  /**
   * Set the business-defined user ID for this user using the referrer querystring.
   *
   * @param querystringField - Name of a querystring name-value pair
   * @param trackers - The tracker identifiers which will be configured
   */
  function setUserIdFromReferrer(querystringField, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.setUserIdFromReferrer(querystringField);
      });
  }
  /**
   * Set the business-defined user ID for this user to the value of a cookie.
   *
   * @param cookieName - Name of the cookie whose value will be assigned to businessUserId
   * @param trackers - The tracker identifiers which will be configured
   */
  function setUserIdFromCookie(cookieName, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.setUserIdFromCookie(cookieName);
      });
  }
  /**
   * Specify the Snowplow collector URL. Specific http or https to force it
   * or leave it off to match the website protocol.
   *
   * @param collectorUrl - The collector URL, with or without protocol
   * @param trackers - The tracker identifiers which will be configured
   */
  function setCollectorUrl(collectorUrl, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.setCollectorUrl(collectorUrl);
      });
  }
  /**
   * Set the buffer size
   * Can be useful if you want to stop batching requests to ensure events start
   * sending closer to event creation
   *
   * @param newBufferSize - The value with which to update the bufferSize to
   * @param trackers - The tracker identifiers which will be flushed
   */
  function setBufferSize(newBufferSize, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.setBufferSize(newBufferSize);
      });
  }
  /**
   * Send all events in the outQueue
   * Only need to use this when sending events with a bufferSize of at least 2
   *
   * @param configuration - The configuration to use following flushing the buffer
   * @param trackers - The tracker identifiers which will be flushed
   */
  function flushBuffer(configuration, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.flushBuffer(configuration);
      });
  }
  /**
   * Track a visit to a web page
   *
   * @param event - The Page View Event properties
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackPageView(event, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.trackPageView(event);
      });
  }
  /**
   * Track a structured event
   * A classic style of event tracking, allows for easier movement between analytics
   * systems. A loosely typed event, creating a Self Describing event is preferred, but
   * useful for interoperability.
   *
   * @param event - The Structured Event properties
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackStructEvent(event, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.core.track(buildStructEvent(event), event.context, event.timestamp);
      });
  }
  /**
   * Track a self-describing event happening on this page.
   * A custom event type, allowing for an event to be tracked using your own custom schema
   * and a data object which conforms to the supplied schema
   *
   * @param event - The event information
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackSelfDescribingEvent(event, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.core.track(buildSelfDescribingEvent({ event: event.event }), event.context, event.timestamp);
      });
  }
  /**
   * All provided contexts will be sent with every event
   *
   * @param contexts - An array of contexts or conditional contexts
   * @param trackers - The tracker identifiers which the global contexts will be added to
   */
  function addGlobalContexts(contexts, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.core.addGlobalContexts(contexts);
      });
  }
  /**
   * All provided contexts will no longer be sent with every event
   *
   * @param contexts - An array of contexts or conditional contexts
   * @param trackers - The tracker identifiers which the global contexts will be remove from
   */
  function removeGlobalContexts(contexts, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.core.removeGlobalContexts(contexts);
      });
  }
  /**
   * Clear all global contexts that are sent with events
   *
   * @param trackers - The tracker identifiers which the global contexts will be cleared from
   */
  function clearGlobalContexts(trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.core.clearGlobalContexts();
      });
  }
  /**
   * Stop regenerating `pageViewId` (available from `web_page` context)
   *
   * @param trackers - The tracker identifiers which the event will preserve their Page View Ids
   */
  function preservePageViewId(trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.preservePageViewId();
      });
  }
  /**
   * Disables anonymous tracking if active (ie. tracker initialized with `anonymousTracking`)
   * For stateStorageStrategy override, uses supplied value first,
   * falls back to one defined in initial config, otherwise uses cookieAndLocalStorage.
   *
   * @param configuration - The configuration for disabling anonymous tracking
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function disableAnonymousTracking(configuration, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.disableAnonymousTracking(configuration);
      });
  }
  /**
   * Enables anonymous tracking (ie. tracker initialized without `anonymousTracking`)
   *
   * @param configuration - The configuration for enabling anonymous tracking
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function enableAnonymousTracking(configuration, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.enableAnonymousTracking(configuration);
      });
  }
  /**
   * Clears all cookies and local storage containing user and session identifiers
   *
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function clearUserData(configuration, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.clearUserData(configuration);
      });
  }
  /**
   * Add a plugin into the plugin collection after trackers have already been initialised
   *
   * @param configuration - The plugin to add
   * @param trackers - The tracker identifiers which the plugin will be added to
   */
  function addPlugin(configuration, trackers) {
      dispatchToTrackers(trackers, function (t) {
          t.addPlugin(configuration);
      });
  }

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  var state = typeof window !== 'undefined' ? createSharedState() : undefined;
  /**
   * Initialise a new tracker
   *
   * @param trackerId - The tracker id - also known as tracker namespace
   * @param endpoint - Collector endpoint in the form collector.mysite.com
   * @param configuration - The initialisation options of the tracker
   */
  function newTracker(trackerId, endpoint, configuration) {
      if (state) {
          return addTracker(trackerId, trackerId, "js-".concat(version), endpoint, state, configuration);
      }
      else {
          return undefined;
      }
  }

  exports.SharedState = SharedState;
  exports.addGlobalContexts = addGlobalContexts;
  exports.addPlugin = addPlugin;
  exports.clearGlobalContexts = clearGlobalContexts;
  exports.clearUserData = clearUserData;
  exports.crossDomainLinker = crossDomainLinker;
  exports.disableActivityTracking = disableActivityTracking;
  exports.disableActivityTrackingCallback = disableActivityTrackingCallback;
  exports.disableAnonymousTracking = disableAnonymousTracking;
  exports.discardBrace = discardBrace;
  exports.discardHashTag = discardHashTag;
  exports.enableActivityTracking = enableActivityTracking;
  exports.enableActivityTrackingCallback = enableActivityTrackingCallback;
  exports.enableAnonymousTracking = enableAnonymousTracking;
  exports.flushBuffer = flushBuffer;
  exports.newSession = newSession;
  exports.newTracker = newTracker;
  exports.preservePageViewId = preservePageViewId;
  exports.removeGlobalContexts = removeGlobalContexts;
  exports.setBufferSize = setBufferSize;
  exports.setCollectorUrl = setCollectorUrl;
  exports.setCookiePath = setCookiePath;
  exports.setCustomUrl = setCustomUrl;
  exports.setDocumentTitle = setDocumentTitle;
  exports.setOptOutCookie = setOptOutCookie;
  exports.setReferrerUrl = setReferrerUrl;
  exports.setUserId = setUserId;
  exports.setUserIdFromCookie = setUserIdFromCookie;
  exports.setUserIdFromLocation = setUserIdFromLocation;
  exports.setUserIdFromReferrer = setUserIdFromReferrer;
  exports.setVisitorCookieTimeout = setVisitorCookieTimeout;
  exports.trackPageView = trackPageView;
  exports.trackSelfDescribingEvent = trackSelfDescribingEvent;
  exports.trackStructEvent = trackStructEvent;
  exports.updatePageActivity = updatePageActivity;
  exports.version = version;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=index.umd.js.map
